package com.tanpu.fund.entity.generator;

import java.util.Date;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
    * 基金托管银行信息
    */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class FundBank {
    private String fundId;

    /**
    * 银行code
    */
    private String bankCode;

    private String bankId;

    /**
    * 银行名称
    */
    private String bankName;

    /**
    * 账号id
    */
    private String fundAccount;

    /**
    * 户名
    */
    private String accountName;

    private String createBy;

    private Date createTime;

    private String updateBy;

    private Date updateTime;

    private Integer deleteTag;
}