package com.tanpu.fund.entity.generator;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

/**
 * @author: zhoupeng
 * @email: zhoupeng_08@163.com
 */
public class FundRiskadjretStatsExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public FundRiskadjretStatsExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        protected void addCriterionForJDBCDate(String condition, Date value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value.getTime()), property);
        }

        protected void addCriterionForJDBCDate(String condition, List<Date> values, String property) {
            if (values == null || values.size() == 0) {
                throw new RuntimeException("Value list for " + property + " cannot be null or empty");
            }
            List<java.sql.Date> dateList = new ArrayList<>();
            Iterator<Date> iter = values.iterator();
            while (iter.hasNext()) {
                dateList.add(new java.sql.Date(iter.next().getTime()));
            }
            addCriterion(condition, dateList, property);
        }

        protected void addCriterionForJDBCDate(String condition, Date value1, Date value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value1.getTime()), new java.sql.Date(value2.getTime()), property);
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andFundIdIsNull() {
            addCriterion("fund_id is null");
            return (Criteria) this;
        }

        public Criteria andFundIdIsNotNull() {
            addCriterion("fund_id is not null");
            return (Criteria) this;
        }

        public Criteria andFundIdEqualTo(String value) {
            addCriterion("fund_id =", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdNotEqualTo(String value) {
            addCriterion("fund_id <>", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdGreaterThan(String value) {
            addCriterion("fund_id >", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdGreaterThanOrEqualTo(String value) {
            addCriterion("fund_id >=", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdLessThan(String value) {
            addCriterion("fund_id <", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdLessThanOrEqualTo(String value) {
            addCriterion("fund_id <=", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdLike(String value) {
            addCriterion("fund_id like", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdNotLike(String value) {
            addCriterion("fund_id not like", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdIn(List<String> values) {
            addCriterion("fund_id in", values, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdNotIn(List<String> values) {
            addCriterion("fund_id not in", values, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdBetween(String value1, String value2) {
            addCriterion("fund_id between", value1, value2, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdNotBetween(String value1, String value2) {
            addCriterion("fund_id not between", value1, value2, "fundId");
            return (Criteria) this;
        }

        public Criteria andEndDateIsNull() {
            addCriterion("end_date is null");
            return (Criteria) this;
        }

        public Criteria andEndDateIsNotNull() {
            addCriterion("end_date is not null");
            return (Criteria) this;
        }

        public Criteria andEndDateEqualTo(Date value) {
            addCriterionForJDBCDate("end_date =", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("end_date <>", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateGreaterThan(Date value) {
            addCriterionForJDBCDate("end_date >", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("end_date >=", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateLessThan(Date value) {
            addCriterionForJDBCDate("end_date <", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("end_date <=", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateIn(List<Date> values) {
            addCriterionForJDBCDate("end_date in", values, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("end_date not in", values, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("end_date between", value1, value2, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("end_date not between", value1, value2, "endDate");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yIsNull() {
            addCriterion("sharperatio_1y is null");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yIsNotNull() {
            addCriterion("sharperatio_1y is not null");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yEqualTo(BigDecimal value) {
            addCriterion("sharperatio_1y =", value, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yNotEqualTo(BigDecimal value) {
            addCriterion("sharperatio_1y <>", value, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yGreaterThan(BigDecimal value) {
            addCriterion("sharperatio_1y >", value, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_1y >=", value, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yLessThan(BigDecimal value) {
            addCriterion("sharperatio_1y <", value, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_1y <=", value, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yIn(List<BigDecimal> values) {
            addCriterion("sharperatio_1y in", values, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yNotIn(List<BigDecimal> values) {
            addCriterion("sharperatio_1y not in", values, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_1y between", value1, value2, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_1y not between", value1, value2, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yIsNull() {
            addCriterion("sharperatio_2y is null");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yIsNotNull() {
            addCriterion("sharperatio_2y is not null");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yEqualTo(BigDecimal value) {
            addCriterion("sharperatio_2y =", value, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yNotEqualTo(BigDecimal value) {
            addCriterion("sharperatio_2y <>", value, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yGreaterThan(BigDecimal value) {
            addCriterion("sharperatio_2y >", value, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_2y >=", value, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yLessThan(BigDecimal value) {
            addCriterion("sharperatio_2y <", value, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_2y <=", value, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yIn(List<BigDecimal> values) {
            addCriterion("sharperatio_2y in", values, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yNotIn(List<BigDecimal> values) {
            addCriterion("sharperatio_2y not in", values, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_2y between", value1, value2, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_2y not between", value1, value2, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yIsNull() {
            addCriterion("sharperatio_3y is null");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yIsNotNull() {
            addCriterion("sharperatio_3y is not null");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yEqualTo(BigDecimal value) {
            addCriterion("sharperatio_3y =", value, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yNotEqualTo(BigDecimal value) {
            addCriterion("sharperatio_3y <>", value, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yGreaterThan(BigDecimal value) {
            addCriterion("sharperatio_3y >", value, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_3y >=", value, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yLessThan(BigDecimal value) {
            addCriterion("sharperatio_3y <", value, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_3y <=", value, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yIn(List<BigDecimal> values) {
            addCriterion("sharperatio_3y in", values, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yNotIn(List<BigDecimal> values) {
            addCriterion("sharperatio_3y not in", values, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_3y between", value1, value2, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_3y not between", value1, value2, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yIsNull() {
            addCriterion("sharperatio_4y is null");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yIsNotNull() {
            addCriterion("sharperatio_4y is not null");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yEqualTo(BigDecimal value) {
            addCriterion("sharperatio_4y =", value, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yNotEqualTo(BigDecimal value) {
            addCriterion("sharperatio_4y <>", value, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yGreaterThan(BigDecimal value) {
            addCriterion("sharperatio_4y >", value, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_4y >=", value, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yLessThan(BigDecimal value) {
            addCriterion("sharperatio_4y <", value, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_4y <=", value, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yIn(List<BigDecimal> values) {
            addCriterion("sharperatio_4y in", values, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yNotIn(List<BigDecimal> values) {
            addCriterion("sharperatio_4y not in", values, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_4y between", value1, value2, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_4y not between", value1, value2, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yIsNull() {
            addCriterion("sharperatio_5y is null");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yIsNotNull() {
            addCriterion("sharperatio_5y is not null");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yEqualTo(BigDecimal value) {
            addCriterion("sharperatio_5y =", value, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yNotEqualTo(BigDecimal value) {
            addCriterion("sharperatio_5y <>", value, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yGreaterThan(BigDecimal value) {
            addCriterion("sharperatio_5y >", value, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_5y >=", value, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yLessThan(BigDecimal value) {
            addCriterion("sharperatio_5y <", value, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_5y <=", value, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yIn(List<BigDecimal> values) {
            addCriterion("sharperatio_5y in", values, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yNotIn(List<BigDecimal> values) {
            addCriterion("sharperatio_5y not in", values, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_5y between", value1, value2, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_5y not between", value1, value2, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepIsNull() {
            addCriterion("sharperatio_incep is null");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepIsNotNull() {
            addCriterion("sharperatio_incep is not null");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepEqualTo(BigDecimal value) {
            addCriterion("sharperatio_incep =", value, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepNotEqualTo(BigDecimal value) {
            addCriterion("sharperatio_incep <>", value, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepGreaterThan(BigDecimal value) {
            addCriterion("sharperatio_incep >", value, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_incep >=", value, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepLessThan(BigDecimal value) {
            addCriterion("sharperatio_incep <", value, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_incep <=", value, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepIn(List<BigDecimal> values) {
            addCriterion("sharperatio_incep in", values, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepNotIn(List<BigDecimal> values) {
            addCriterion("sharperatio_incep not in", values, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_incep between", value1, value2, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_incep not between", value1, value2, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andSortinoratio1yIsNull() {
            addCriterion("sortinoratio_1y is null");
            return (Criteria) this;
        }

        public Criteria andSortinoratio1yIsNotNull() {
            addCriterion("sortinoratio_1y is not null");
            return (Criteria) this;
        }

        public Criteria andSortinoratio1yEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_1y =", value, "sortinoratio1y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio1yNotEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_1y <>", value, "sortinoratio1y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio1yGreaterThan(BigDecimal value) {
            addCriterion("sortinoratio_1y >", value, "sortinoratio1y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio1yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_1y >=", value, "sortinoratio1y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio1yLessThan(BigDecimal value) {
            addCriterion("sortinoratio_1y <", value, "sortinoratio1y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio1yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_1y <=", value, "sortinoratio1y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio1yIn(List<BigDecimal> values) {
            addCriterion("sortinoratio_1y in", values, "sortinoratio1y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio1yNotIn(List<BigDecimal> values) {
            addCriterion("sortinoratio_1y not in", values, "sortinoratio1y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio1yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sortinoratio_1y between", value1, value2, "sortinoratio1y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio1yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sortinoratio_1y not between", value1, value2, "sortinoratio1y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio2yIsNull() {
            addCriterion("sortinoratio_2y is null");
            return (Criteria) this;
        }

        public Criteria andSortinoratio2yIsNotNull() {
            addCriterion("sortinoratio_2y is not null");
            return (Criteria) this;
        }

        public Criteria andSortinoratio2yEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_2y =", value, "sortinoratio2y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio2yNotEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_2y <>", value, "sortinoratio2y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio2yGreaterThan(BigDecimal value) {
            addCriterion("sortinoratio_2y >", value, "sortinoratio2y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio2yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_2y >=", value, "sortinoratio2y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio2yLessThan(BigDecimal value) {
            addCriterion("sortinoratio_2y <", value, "sortinoratio2y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio2yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_2y <=", value, "sortinoratio2y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio2yIn(List<BigDecimal> values) {
            addCriterion("sortinoratio_2y in", values, "sortinoratio2y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio2yNotIn(List<BigDecimal> values) {
            addCriterion("sortinoratio_2y not in", values, "sortinoratio2y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio2yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sortinoratio_2y between", value1, value2, "sortinoratio2y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio2yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sortinoratio_2y not between", value1, value2, "sortinoratio2y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio3yIsNull() {
            addCriterion("sortinoratio_3y is null");
            return (Criteria) this;
        }

        public Criteria andSortinoratio3yIsNotNull() {
            addCriterion("sortinoratio_3y is not null");
            return (Criteria) this;
        }

        public Criteria andSortinoratio3yEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_3y =", value, "sortinoratio3y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio3yNotEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_3y <>", value, "sortinoratio3y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio3yGreaterThan(BigDecimal value) {
            addCriterion("sortinoratio_3y >", value, "sortinoratio3y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio3yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_3y >=", value, "sortinoratio3y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio3yLessThan(BigDecimal value) {
            addCriterion("sortinoratio_3y <", value, "sortinoratio3y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio3yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_3y <=", value, "sortinoratio3y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio3yIn(List<BigDecimal> values) {
            addCriterion("sortinoratio_3y in", values, "sortinoratio3y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio3yNotIn(List<BigDecimal> values) {
            addCriterion("sortinoratio_3y not in", values, "sortinoratio3y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio3yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sortinoratio_3y between", value1, value2, "sortinoratio3y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio3yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sortinoratio_3y not between", value1, value2, "sortinoratio3y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio4yIsNull() {
            addCriterion("sortinoratio_4y is null");
            return (Criteria) this;
        }

        public Criteria andSortinoratio4yIsNotNull() {
            addCriterion("sortinoratio_4y is not null");
            return (Criteria) this;
        }

        public Criteria andSortinoratio4yEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_4y =", value, "sortinoratio4y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio4yNotEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_4y <>", value, "sortinoratio4y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio4yGreaterThan(BigDecimal value) {
            addCriterion("sortinoratio_4y >", value, "sortinoratio4y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio4yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_4y >=", value, "sortinoratio4y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio4yLessThan(BigDecimal value) {
            addCriterion("sortinoratio_4y <", value, "sortinoratio4y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio4yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_4y <=", value, "sortinoratio4y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio4yIn(List<BigDecimal> values) {
            addCriterion("sortinoratio_4y in", values, "sortinoratio4y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio4yNotIn(List<BigDecimal> values) {
            addCriterion("sortinoratio_4y not in", values, "sortinoratio4y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio4yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sortinoratio_4y between", value1, value2, "sortinoratio4y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio4yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sortinoratio_4y not between", value1, value2, "sortinoratio4y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio5yIsNull() {
            addCriterion("sortinoratio_5y is null");
            return (Criteria) this;
        }

        public Criteria andSortinoratio5yIsNotNull() {
            addCriterion("sortinoratio_5y is not null");
            return (Criteria) this;
        }

        public Criteria andSortinoratio5yEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_5y =", value, "sortinoratio5y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio5yNotEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_5y <>", value, "sortinoratio5y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio5yGreaterThan(BigDecimal value) {
            addCriterion("sortinoratio_5y >", value, "sortinoratio5y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio5yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_5y >=", value, "sortinoratio5y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio5yLessThan(BigDecimal value) {
            addCriterion("sortinoratio_5y <", value, "sortinoratio5y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio5yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_5y <=", value, "sortinoratio5y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio5yIn(List<BigDecimal> values) {
            addCriterion("sortinoratio_5y in", values, "sortinoratio5y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio5yNotIn(List<BigDecimal> values) {
            addCriterion("sortinoratio_5y not in", values, "sortinoratio5y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio5yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sortinoratio_5y between", value1, value2, "sortinoratio5y");
            return (Criteria) this;
        }

        public Criteria andSortinoratio5yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sortinoratio_5y not between", value1, value2, "sortinoratio5y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioIncepIsNull() {
            addCriterion("sortinoratio_incep is null");
            return (Criteria) this;
        }

        public Criteria andSortinoratioIncepIsNotNull() {
            addCriterion("sortinoratio_incep is not null");
            return (Criteria) this;
        }

        public Criteria andSortinoratioIncepEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_incep =", value, "sortinoratioIncep");
            return (Criteria) this;
        }

        public Criteria andSortinoratioIncepNotEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_incep <>", value, "sortinoratioIncep");
            return (Criteria) this;
        }

        public Criteria andSortinoratioIncepGreaterThan(BigDecimal value) {
            addCriterion("sortinoratio_incep >", value, "sortinoratioIncep");
            return (Criteria) this;
        }

        public Criteria andSortinoratioIncepGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_incep >=", value, "sortinoratioIncep");
            return (Criteria) this;
        }

        public Criteria andSortinoratioIncepLessThan(BigDecimal value) {
            addCriterion("sortinoratio_incep <", value, "sortinoratioIncep");
            return (Criteria) this;
        }

        public Criteria andSortinoratioIncepLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_incep <=", value, "sortinoratioIncep");
            return (Criteria) this;
        }

        public Criteria andSortinoratioIncepIn(List<BigDecimal> values) {
            addCriterion("sortinoratio_incep in", values, "sortinoratioIncep");
            return (Criteria) this;
        }

        public Criteria andSortinoratioIncepNotIn(List<BigDecimal> values) {
            addCriterion("sortinoratio_incep not in", values, "sortinoratioIncep");
            return (Criteria) this;
        }

        public Criteria andSortinoratioIncepBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sortinoratio_incep between", value1, value2, "sortinoratioIncep");
            return (Criteria) this;
        }

        public Criteria andSortinoratioIncepNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sortinoratio_incep not between", value1, value2, "sortinoratioIncep");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar1yIsNull() {
            addCriterion("sortinoratio_MAR_1y is null");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar1yIsNotNull() {
            addCriterion("sortinoratio_MAR_1y is not null");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar1yEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_MAR_1y =", value, "sortinoratioMar1y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar1yNotEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_MAR_1y <>", value, "sortinoratioMar1y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar1yGreaterThan(BigDecimal value) {
            addCriterion("sortinoratio_MAR_1y >", value, "sortinoratioMar1y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar1yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_MAR_1y >=", value, "sortinoratioMar1y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar1yLessThan(BigDecimal value) {
            addCriterion("sortinoratio_MAR_1y <", value, "sortinoratioMar1y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar1yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_MAR_1y <=", value, "sortinoratioMar1y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar1yIn(List<BigDecimal> values) {
            addCriterion("sortinoratio_MAR_1y in", values, "sortinoratioMar1y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar1yNotIn(List<BigDecimal> values) {
            addCriterion("sortinoratio_MAR_1y not in", values, "sortinoratioMar1y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar1yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sortinoratio_MAR_1y between", value1, value2, "sortinoratioMar1y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar1yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sortinoratio_MAR_1y not between", value1, value2, "sortinoratioMar1y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar2yIsNull() {
            addCriterion("sortinoratio_MAR_2y is null");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar2yIsNotNull() {
            addCriterion("sortinoratio_MAR_2y is not null");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar2yEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_MAR_2y =", value, "sortinoratioMar2y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar2yNotEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_MAR_2y <>", value, "sortinoratioMar2y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar2yGreaterThan(BigDecimal value) {
            addCriterion("sortinoratio_MAR_2y >", value, "sortinoratioMar2y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar2yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_MAR_2y >=", value, "sortinoratioMar2y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar2yLessThan(BigDecimal value) {
            addCriterion("sortinoratio_MAR_2y <", value, "sortinoratioMar2y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar2yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_MAR_2y <=", value, "sortinoratioMar2y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar2yIn(List<BigDecimal> values) {
            addCriterion("sortinoratio_MAR_2y in", values, "sortinoratioMar2y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar2yNotIn(List<BigDecimal> values) {
            addCriterion("sortinoratio_MAR_2y not in", values, "sortinoratioMar2y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar2yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sortinoratio_MAR_2y between", value1, value2, "sortinoratioMar2y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar2yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sortinoratio_MAR_2y not between", value1, value2, "sortinoratioMar2y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar3yIsNull() {
            addCriterion("sortinoratio_MAR_3y is null");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar3yIsNotNull() {
            addCriterion("sortinoratio_MAR_3y is not null");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar3yEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_MAR_3y =", value, "sortinoratioMar3y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar3yNotEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_MAR_3y <>", value, "sortinoratioMar3y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar3yGreaterThan(BigDecimal value) {
            addCriterion("sortinoratio_MAR_3y >", value, "sortinoratioMar3y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar3yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_MAR_3y >=", value, "sortinoratioMar3y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar3yLessThan(BigDecimal value) {
            addCriterion("sortinoratio_MAR_3y <", value, "sortinoratioMar3y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar3yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_MAR_3y <=", value, "sortinoratioMar3y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar3yIn(List<BigDecimal> values) {
            addCriterion("sortinoratio_MAR_3y in", values, "sortinoratioMar3y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar3yNotIn(List<BigDecimal> values) {
            addCriterion("sortinoratio_MAR_3y not in", values, "sortinoratioMar3y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar3yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sortinoratio_MAR_3y between", value1, value2, "sortinoratioMar3y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar3yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sortinoratio_MAR_3y not between", value1, value2, "sortinoratioMar3y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar4yIsNull() {
            addCriterion("sortinoratio_MAR_4y is null");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar4yIsNotNull() {
            addCriterion("sortinoratio_MAR_4y is not null");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar4yEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_MAR_4y =", value, "sortinoratioMar4y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar4yNotEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_MAR_4y <>", value, "sortinoratioMar4y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar4yGreaterThan(BigDecimal value) {
            addCriterion("sortinoratio_MAR_4y >", value, "sortinoratioMar4y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar4yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_MAR_4y >=", value, "sortinoratioMar4y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar4yLessThan(BigDecimal value) {
            addCriterion("sortinoratio_MAR_4y <", value, "sortinoratioMar4y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar4yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_MAR_4y <=", value, "sortinoratioMar4y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar4yIn(List<BigDecimal> values) {
            addCriterion("sortinoratio_MAR_4y in", values, "sortinoratioMar4y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar4yNotIn(List<BigDecimal> values) {
            addCriterion("sortinoratio_MAR_4y not in", values, "sortinoratioMar4y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar4yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sortinoratio_MAR_4y between", value1, value2, "sortinoratioMar4y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar4yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sortinoratio_MAR_4y not between", value1, value2, "sortinoratioMar4y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar5yIsNull() {
            addCriterion("sortinoratio_MAR_5y is null");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar5yIsNotNull() {
            addCriterion("sortinoratio_MAR_5y is not null");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar5yEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_MAR_5y =", value, "sortinoratioMar5y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar5yNotEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_MAR_5y <>", value, "sortinoratioMar5y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar5yGreaterThan(BigDecimal value) {
            addCriterion("sortinoratio_MAR_5y >", value, "sortinoratioMar5y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar5yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_MAR_5y >=", value, "sortinoratioMar5y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar5yLessThan(BigDecimal value) {
            addCriterion("sortinoratio_MAR_5y <", value, "sortinoratioMar5y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar5yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_MAR_5y <=", value, "sortinoratioMar5y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar5yIn(List<BigDecimal> values) {
            addCriterion("sortinoratio_MAR_5y in", values, "sortinoratioMar5y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar5yNotIn(List<BigDecimal> values) {
            addCriterion("sortinoratio_MAR_5y not in", values, "sortinoratioMar5y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar5yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sortinoratio_MAR_5y between", value1, value2, "sortinoratioMar5y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMar5yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sortinoratio_MAR_5y not between", value1, value2, "sortinoratioMar5y");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMarIncepIsNull() {
            addCriterion("sortinoratio_MAR_incep is null");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMarIncepIsNotNull() {
            addCriterion("sortinoratio_MAR_incep is not null");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMarIncepEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_MAR_incep =", value, "sortinoratioMarIncep");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMarIncepNotEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_MAR_incep <>", value, "sortinoratioMarIncep");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMarIncepGreaterThan(BigDecimal value) {
            addCriterion("sortinoratio_MAR_incep >", value, "sortinoratioMarIncep");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMarIncepGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_MAR_incep >=", value, "sortinoratioMarIncep");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMarIncepLessThan(BigDecimal value) {
            addCriterion("sortinoratio_MAR_incep <", value, "sortinoratioMarIncep");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMarIncepLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sortinoratio_MAR_incep <=", value, "sortinoratioMarIncep");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMarIncepIn(List<BigDecimal> values) {
            addCriterion("sortinoratio_MAR_incep in", values, "sortinoratioMarIncep");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMarIncepNotIn(List<BigDecimal> values) {
            addCriterion("sortinoratio_MAR_incep not in", values, "sortinoratioMarIncep");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMarIncepBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sortinoratio_MAR_incep between", value1, value2, "sortinoratioMarIncep");
            return (Criteria) this;
        }

        public Criteria andSortinoratioMarIncepNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sortinoratio_MAR_incep not between", value1, value2, "sortinoratioMarIncep");
            return (Criteria) this;
        }

        public Criteria andTreynorratio1yIsNull() {
            addCriterion("treynorratio_1y is null");
            return (Criteria) this;
        }

        public Criteria andTreynorratio1yIsNotNull() {
            addCriterion("treynorratio_1y is not null");
            return (Criteria) this;
        }

        public Criteria andTreynorratio1yEqualTo(BigDecimal value) {
            addCriterion("treynorratio_1y =", value, "treynorratio1y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio1yNotEqualTo(BigDecimal value) {
            addCriterion("treynorratio_1y <>", value, "treynorratio1y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio1yGreaterThan(BigDecimal value) {
            addCriterion("treynorratio_1y >", value, "treynorratio1y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio1yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("treynorratio_1y >=", value, "treynorratio1y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio1yLessThan(BigDecimal value) {
            addCriterion("treynorratio_1y <", value, "treynorratio1y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio1yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("treynorratio_1y <=", value, "treynorratio1y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio1yIn(List<BigDecimal> values) {
            addCriterion("treynorratio_1y in", values, "treynorratio1y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio1yNotIn(List<BigDecimal> values) {
            addCriterion("treynorratio_1y not in", values, "treynorratio1y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio1yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("treynorratio_1y between", value1, value2, "treynorratio1y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio1yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("treynorratio_1y not between", value1, value2, "treynorratio1y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio2yIsNull() {
            addCriterion("treynorratio_2y is null");
            return (Criteria) this;
        }

        public Criteria andTreynorratio2yIsNotNull() {
            addCriterion("treynorratio_2y is not null");
            return (Criteria) this;
        }

        public Criteria andTreynorratio2yEqualTo(BigDecimal value) {
            addCriterion("treynorratio_2y =", value, "treynorratio2y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio2yNotEqualTo(BigDecimal value) {
            addCriterion("treynorratio_2y <>", value, "treynorratio2y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio2yGreaterThan(BigDecimal value) {
            addCriterion("treynorratio_2y >", value, "treynorratio2y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio2yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("treynorratio_2y >=", value, "treynorratio2y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio2yLessThan(BigDecimal value) {
            addCriterion("treynorratio_2y <", value, "treynorratio2y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio2yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("treynorratio_2y <=", value, "treynorratio2y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio2yIn(List<BigDecimal> values) {
            addCriterion("treynorratio_2y in", values, "treynorratio2y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio2yNotIn(List<BigDecimal> values) {
            addCriterion("treynorratio_2y not in", values, "treynorratio2y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio2yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("treynorratio_2y between", value1, value2, "treynorratio2y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio2yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("treynorratio_2y not between", value1, value2, "treynorratio2y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio3yIsNull() {
            addCriterion("treynorratio_3y is null");
            return (Criteria) this;
        }

        public Criteria andTreynorratio3yIsNotNull() {
            addCriterion("treynorratio_3y is not null");
            return (Criteria) this;
        }

        public Criteria andTreynorratio3yEqualTo(BigDecimal value) {
            addCriterion("treynorratio_3y =", value, "treynorratio3y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio3yNotEqualTo(BigDecimal value) {
            addCriterion("treynorratio_3y <>", value, "treynorratio3y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio3yGreaterThan(BigDecimal value) {
            addCriterion("treynorratio_3y >", value, "treynorratio3y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio3yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("treynorratio_3y >=", value, "treynorratio3y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio3yLessThan(BigDecimal value) {
            addCriterion("treynorratio_3y <", value, "treynorratio3y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio3yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("treynorratio_3y <=", value, "treynorratio3y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio3yIn(List<BigDecimal> values) {
            addCriterion("treynorratio_3y in", values, "treynorratio3y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio3yNotIn(List<BigDecimal> values) {
            addCriterion("treynorratio_3y not in", values, "treynorratio3y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio3yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("treynorratio_3y between", value1, value2, "treynorratio3y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio3yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("treynorratio_3y not between", value1, value2, "treynorratio3y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio4yIsNull() {
            addCriterion("treynorratio_4y is null");
            return (Criteria) this;
        }

        public Criteria andTreynorratio4yIsNotNull() {
            addCriterion("treynorratio_4y is not null");
            return (Criteria) this;
        }

        public Criteria andTreynorratio4yEqualTo(BigDecimal value) {
            addCriterion("treynorratio_4y =", value, "treynorratio4y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio4yNotEqualTo(BigDecimal value) {
            addCriterion("treynorratio_4y <>", value, "treynorratio4y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio4yGreaterThan(BigDecimal value) {
            addCriterion("treynorratio_4y >", value, "treynorratio4y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio4yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("treynorratio_4y >=", value, "treynorratio4y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio4yLessThan(BigDecimal value) {
            addCriterion("treynorratio_4y <", value, "treynorratio4y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio4yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("treynorratio_4y <=", value, "treynorratio4y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio4yIn(List<BigDecimal> values) {
            addCriterion("treynorratio_4y in", values, "treynorratio4y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio4yNotIn(List<BigDecimal> values) {
            addCriterion("treynorratio_4y not in", values, "treynorratio4y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio4yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("treynorratio_4y between", value1, value2, "treynorratio4y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio4yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("treynorratio_4y not between", value1, value2, "treynorratio4y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio5yIsNull() {
            addCriterion("treynorratio_5y is null");
            return (Criteria) this;
        }

        public Criteria andTreynorratio5yIsNotNull() {
            addCriterion("treynorratio_5y is not null");
            return (Criteria) this;
        }

        public Criteria andTreynorratio5yEqualTo(BigDecimal value) {
            addCriterion("treynorratio_5y =", value, "treynorratio5y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio5yNotEqualTo(BigDecimal value) {
            addCriterion("treynorratio_5y <>", value, "treynorratio5y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio5yGreaterThan(BigDecimal value) {
            addCriterion("treynorratio_5y >", value, "treynorratio5y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio5yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("treynorratio_5y >=", value, "treynorratio5y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio5yLessThan(BigDecimal value) {
            addCriterion("treynorratio_5y <", value, "treynorratio5y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio5yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("treynorratio_5y <=", value, "treynorratio5y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio5yIn(List<BigDecimal> values) {
            addCriterion("treynorratio_5y in", values, "treynorratio5y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio5yNotIn(List<BigDecimal> values) {
            addCriterion("treynorratio_5y not in", values, "treynorratio5y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio5yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("treynorratio_5y between", value1, value2, "treynorratio5y");
            return (Criteria) this;
        }

        public Criteria andTreynorratio5yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("treynorratio_5y not between", value1, value2, "treynorratio5y");
            return (Criteria) this;
        }

        public Criteria andTreynorratioIncepIsNull() {
            addCriterion("treynorratio_incep is null");
            return (Criteria) this;
        }

        public Criteria andTreynorratioIncepIsNotNull() {
            addCriterion("treynorratio_incep is not null");
            return (Criteria) this;
        }

        public Criteria andTreynorratioIncepEqualTo(BigDecimal value) {
            addCriterion("treynorratio_incep =", value, "treynorratioIncep");
            return (Criteria) this;
        }

        public Criteria andTreynorratioIncepNotEqualTo(BigDecimal value) {
            addCriterion("treynorratio_incep <>", value, "treynorratioIncep");
            return (Criteria) this;
        }

        public Criteria andTreynorratioIncepGreaterThan(BigDecimal value) {
            addCriterion("treynorratio_incep >", value, "treynorratioIncep");
            return (Criteria) this;
        }

        public Criteria andTreynorratioIncepGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("treynorratio_incep >=", value, "treynorratioIncep");
            return (Criteria) this;
        }

        public Criteria andTreynorratioIncepLessThan(BigDecimal value) {
            addCriterion("treynorratio_incep <", value, "treynorratioIncep");
            return (Criteria) this;
        }

        public Criteria andTreynorratioIncepLessThanOrEqualTo(BigDecimal value) {
            addCriterion("treynorratio_incep <=", value, "treynorratioIncep");
            return (Criteria) this;
        }

        public Criteria andTreynorratioIncepIn(List<BigDecimal> values) {
            addCriterion("treynorratio_incep in", values, "treynorratioIncep");
            return (Criteria) this;
        }

        public Criteria andTreynorratioIncepNotIn(List<BigDecimal> values) {
            addCriterion("treynorratio_incep not in", values, "treynorratioIncep");
            return (Criteria) this;
        }

        public Criteria andTreynorratioIncepBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("treynorratio_incep between", value1, value2, "treynorratioIncep");
            return (Criteria) this;
        }

        public Criteria andTreynorratioIncepNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("treynorratio_incep not between", value1, value2, "treynorratioIncep");
            return (Criteria) this;
        }

        public Criteria andJensen1yIsNull() {
            addCriterion("jensen_1y is null");
            return (Criteria) this;
        }

        public Criteria andJensen1yIsNotNull() {
            addCriterion("jensen_1y is not null");
            return (Criteria) this;
        }

        public Criteria andJensen1yEqualTo(BigDecimal value) {
            addCriterion("jensen_1y =", value, "jensen1y");
            return (Criteria) this;
        }

        public Criteria andJensen1yNotEqualTo(BigDecimal value) {
            addCriterion("jensen_1y <>", value, "jensen1y");
            return (Criteria) this;
        }

        public Criteria andJensen1yGreaterThan(BigDecimal value) {
            addCriterion("jensen_1y >", value, "jensen1y");
            return (Criteria) this;
        }

        public Criteria andJensen1yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("jensen_1y >=", value, "jensen1y");
            return (Criteria) this;
        }

        public Criteria andJensen1yLessThan(BigDecimal value) {
            addCriterion("jensen_1y <", value, "jensen1y");
            return (Criteria) this;
        }

        public Criteria andJensen1yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("jensen_1y <=", value, "jensen1y");
            return (Criteria) this;
        }

        public Criteria andJensen1yIn(List<BigDecimal> values) {
            addCriterion("jensen_1y in", values, "jensen1y");
            return (Criteria) this;
        }

        public Criteria andJensen1yNotIn(List<BigDecimal> values) {
            addCriterion("jensen_1y not in", values, "jensen1y");
            return (Criteria) this;
        }

        public Criteria andJensen1yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("jensen_1y between", value1, value2, "jensen1y");
            return (Criteria) this;
        }

        public Criteria andJensen1yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("jensen_1y not between", value1, value2, "jensen1y");
            return (Criteria) this;
        }

        public Criteria andJensen2yIsNull() {
            addCriterion("jensen_2y is null");
            return (Criteria) this;
        }

        public Criteria andJensen2yIsNotNull() {
            addCriterion("jensen_2y is not null");
            return (Criteria) this;
        }

        public Criteria andJensen2yEqualTo(BigDecimal value) {
            addCriterion("jensen_2y =", value, "jensen2y");
            return (Criteria) this;
        }

        public Criteria andJensen2yNotEqualTo(BigDecimal value) {
            addCriterion("jensen_2y <>", value, "jensen2y");
            return (Criteria) this;
        }

        public Criteria andJensen2yGreaterThan(BigDecimal value) {
            addCriterion("jensen_2y >", value, "jensen2y");
            return (Criteria) this;
        }

        public Criteria andJensen2yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("jensen_2y >=", value, "jensen2y");
            return (Criteria) this;
        }

        public Criteria andJensen2yLessThan(BigDecimal value) {
            addCriterion("jensen_2y <", value, "jensen2y");
            return (Criteria) this;
        }

        public Criteria andJensen2yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("jensen_2y <=", value, "jensen2y");
            return (Criteria) this;
        }

        public Criteria andJensen2yIn(List<BigDecimal> values) {
            addCriterion("jensen_2y in", values, "jensen2y");
            return (Criteria) this;
        }

        public Criteria andJensen2yNotIn(List<BigDecimal> values) {
            addCriterion("jensen_2y not in", values, "jensen2y");
            return (Criteria) this;
        }

        public Criteria andJensen2yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("jensen_2y between", value1, value2, "jensen2y");
            return (Criteria) this;
        }

        public Criteria andJensen2yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("jensen_2y not between", value1, value2, "jensen2y");
            return (Criteria) this;
        }

        public Criteria andJensen3yIsNull() {
            addCriterion("jensen_3y is null");
            return (Criteria) this;
        }

        public Criteria andJensen3yIsNotNull() {
            addCriterion("jensen_3y is not null");
            return (Criteria) this;
        }

        public Criteria andJensen3yEqualTo(BigDecimal value) {
            addCriterion("jensen_3y =", value, "jensen3y");
            return (Criteria) this;
        }

        public Criteria andJensen3yNotEqualTo(BigDecimal value) {
            addCriterion("jensen_3y <>", value, "jensen3y");
            return (Criteria) this;
        }

        public Criteria andJensen3yGreaterThan(BigDecimal value) {
            addCriterion("jensen_3y >", value, "jensen3y");
            return (Criteria) this;
        }

        public Criteria andJensen3yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("jensen_3y >=", value, "jensen3y");
            return (Criteria) this;
        }

        public Criteria andJensen3yLessThan(BigDecimal value) {
            addCriterion("jensen_3y <", value, "jensen3y");
            return (Criteria) this;
        }

        public Criteria andJensen3yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("jensen_3y <=", value, "jensen3y");
            return (Criteria) this;
        }

        public Criteria andJensen3yIn(List<BigDecimal> values) {
            addCriterion("jensen_3y in", values, "jensen3y");
            return (Criteria) this;
        }

        public Criteria andJensen3yNotIn(List<BigDecimal> values) {
            addCriterion("jensen_3y not in", values, "jensen3y");
            return (Criteria) this;
        }

        public Criteria andJensen3yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("jensen_3y between", value1, value2, "jensen3y");
            return (Criteria) this;
        }

        public Criteria andJensen3yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("jensen_3y not between", value1, value2, "jensen3y");
            return (Criteria) this;
        }

        public Criteria andJensen4yIsNull() {
            addCriterion("jensen_4y is null");
            return (Criteria) this;
        }

        public Criteria andJensen4yIsNotNull() {
            addCriterion("jensen_4y is not null");
            return (Criteria) this;
        }

        public Criteria andJensen4yEqualTo(BigDecimal value) {
            addCriterion("jensen_4y =", value, "jensen4y");
            return (Criteria) this;
        }

        public Criteria andJensen4yNotEqualTo(BigDecimal value) {
            addCriterion("jensen_4y <>", value, "jensen4y");
            return (Criteria) this;
        }

        public Criteria andJensen4yGreaterThan(BigDecimal value) {
            addCriterion("jensen_4y >", value, "jensen4y");
            return (Criteria) this;
        }

        public Criteria andJensen4yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("jensen_4y >=", value, "jensen4y");
            return (Criteria) this;
        }

        public Criteria andJensen4yLessThan(BigDecimal value) {
            addCriterion("jensen_4y <", value, "jensen4y");
            return (Criteria) this;
        }

        public Criteria andJensen4yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("jensen_4y <=", value, "jensen4y");
            return (Criteria) this;
        }

        public Criteria andJensen4yIn(List<BigDecimal> values) {
            addCriterion("jensen_4y in", values, "jensen4y");
            return (Criteria) this;
        }

        public Criteria andJensen4yNotIn(List<BigDecimal> values) {
            addCriterion("jensen_4y not in", values, "jensen4y");
            return (Criteria) this;
        }

        public Criteria andJensen4yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("jensen_4y between", value1, value2, "jensen4y");
            return (Criteria) this;
        }

        public Criteria andJensen4yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("jensen_4y not between", value1, value2, "jensen4y");
            return (Criteria) this;
        }

        public Criteria andJensen5yIsNull() {
            addCriterion("jensen_5y is null");
            return (Criteria) this;
        }

        public Criteria andJensen5yIsNotNull() {
            addCriterion("jensen_5y is not null");
            return (Criteria) this;
        }

        public Criteria andJensen5yEqualTo(BigDecimal value) {
            addCriterion("jensen_5y =", value, "jensen5y");
            return (Criteria) this;
        }

        public Criteria andJensen5yNotEqualTo(BigDecimal value) {
            addCriterion("jensen_5y <>", value, "jensen5y");
            return (Criteria) this;
        }

        public Criteria andJensen5yGreaterThan(BigDecimal value) {
            addCriterion("jensen_5y >", value, "jensen5y");
            return (Criteria) this;
        }

        public Criteria andJensen5yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("jensen_5y >=", value, "jensen5y");
            return (Criteria) this;
        }

        public Criteria andJensen5yLessThan(BigDecimal value) {
            addCriterion("jensen_5y <", value, "jensen5y");
            return (Criteria) this;
        }

        public Criteria andJensen5yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("jensen_5y <=", value, "jensen5y");
            return (Criteria) this;
        }

        public Criteria andJensen5yIn(List<BigDecimal> values) {
            addCriterion("jensen_5y in", values, "jensen5y");
            return (Criteria) this;
        }

        public Criteria andJensen5yNotIn(List<BigDecimal> values) {
            addCriterion("jensen_5y not in", values, "jensen5y");
            return (Criteria) this;
        }

        public Criteria andJensen5yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("jensen_5y between", value1, value2, "jensen5y");
            return (Criteria) this;
        }

        public Criteria andJensen5yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("jensen_5y not between", value1, value2, "jensen5y");
            return (Criteria) this;
        }

        public Criteria andJensenIncepIsNull() {
            addCriterion("jensen_incep is null");
            return (Criteria) this;
        }

        public Criteria andJensenIncepIsNotNull() {
            addCriterion("jensen_incep is not null");
            return (Criteria) this;
        }

        public Criteria andJensenIncepEqualTo(BigDecimal value) {
            addCriterion("jensen_incep =", value, "jensenIncep");
            return (Criteria) this;
        }

        public Criteria andJensenIncepNotEqualTo(BigDecimal value) {
            addCriterion("jensen_incep <>", value, "jensenIncep");
            return (Criteria) this;
        }

        public Criteria andJensenIncepGreaterThan(BigDecimal value) {
            addCriterion("jensen_incep >", value, "jensenIncep");
            return (Criteria) this;
        }

        public Criteria andJensenIncepGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("jensen_incep >=", value, "jensenIncep");
            return (Criteria) this;
        }

        public Criteria andJensenIncepLessThan(BigDecimal value) {
            addCriterion("jensen_incep <", value, "jensenIncep");
            return (Criteria) this;
        }

        public Criteria andJensenIncepLessThanOrEqualTo(BigDecimal value) {
            addCriterion("jensen_incep <=", value, "jensenIncep");
            return (Criteria) this;
        }

        public Criteria andJensenIncepIn(List<BigDecimal> values) {
            addCriterion("jensen_incep in", values, "jensenIncep");
            return (Criteria) this;
        }

        public Criteria andJensenIncepNotIn(List<BigDecimal> values) {
            addCriterion("jensen_incep not in", values, "jensenIncep");
            return (Criteria) this;
        }

        public Criteria andJensenIncepBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("jensen_incep between", value1, value2, "jensenIncep");
            return (Criteria) this;
        }

        public Criteria andJensenIncepNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("jensen_incep not between", value1, value2, "jensenIncep");
            return (Criteria) this;
        }

        public Criteria andCalmarratio1yIsNull() {
            addCriterion("calmarratio_1y is null");
            return (Criteria) this;
        }

        public Criteria andCalmarratio1yIsNotNull() {
            addCriterion("calmarratio_1y is not null");
            return (Criteria) this;
        }

        public Criteria andCalmarratio1yEqualTo(BigDecimal value) {
            addCriterion("calmarratio_1y =", value, "calmarratio1y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio1yNotEqualTo(BigDecimal value) {
            addCriterion("calmarratio_1y <>", value, "calmarratio1y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio1yGreaterThan(BigDecimal value) {
            addCriterion("calmarratio_1y >", value, "calmarratio1y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio1yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("calmarratio_1y >=", value, "calmarratio1y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio1yLessThan(BigDecimal value) {
            addCriterion("calmarratio_1y <", value, "calmarratio1y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio1yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("calmarratio_1y <=", value, "calmarratio1y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio1yIn(List<BigDecimal> values) {
            addCriterion("calmarratio_1y in", values, "calmarratio1y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio1yNotIn(List<BigDecimal> values) {
            addCriterion("calmarratio_1y not in", values, "calmarratio1y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio1yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("calmarratio_1y between", value1, value2, "calmarratio1y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio1yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("calmarratio_1y not between", value1, value2, "calmarratio1y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio2yIsNull() {
            addCriterion("calmarratio_2y is null");
            return (Criteria) this;
        }

        public Criteria andCalmarratio2yIsNotNull() {
            addCriterion("calmarratio_2y is not null");
            return (Criteria) this;
        }

        public Criteria andCalmarratio2yEqualTo(BigDecimal value) {
            addCriterion("calmarratio_2y =", value, "calmarratio2y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio2yNotEqualTo(BigDecimal value) {
            addCriterion("calmarratio_2y <>", value, "calmarratio2y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio2yGreaterThan(BigDecimal value) {
            addCriterion("calmarratio_2y >", value, "calmarratio2y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio2yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("calmarratio_2y >=", value, "calmarratio2y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio2yLessThan(BigDecimal value) {
            addCriterion("calmarratio_2y <", value, "calmarratio2y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio2yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("calmarratio_2y <=", value, "calmarratio2y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio2yIn(List<BigDecimal> values) {
            addCriterion("calmarratio_2y in", values, "calmarratio2y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio2yNotIn(List<BigDecimal> values) {
            addCriterion("calmarratio_2y not in", values, "calmarratio2y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio2yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("calmarratio_2y between", value1, value2, "calmarratio2y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio2yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("calmarratio_2y not between", value1, value2, "calmarratio2y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio3yIsNull() {
            addCriterion("calmarratio_3y is null");
            return (Criteria) this;
        }

        public Criteria andCalmarratio3yIsNotNull() {
            addCriterion("calmarratio_3y is not null");
            return (Criteria) this;
        }

        public Criteria andCalmarratio3yEqualTo(BigDecimal value) {
            addCriterion("calmarratio_3y =", value, "calmarratio3y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio3yNotEqualTo(BigDecimal value) {
            addCriterion("calmarratio_3y <>", value, "calmarratio3y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio3yGreaterThan(BigDecimal value) {
            addCriterion("calmarratio_3y >", value, "calmarratio3y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio3yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("calmarratio_3y >=", value, "calmarratio3y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio3yLessThan(BigDecimal value) {
            addCriterion("calmarratio_3y <", value, "calmarratio3y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio3yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("calmarratio_3y <=", value, "calmarratio3y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio3yIn(List<BigDecimal> values) {
            addCriterion("calmarratio_3y in", values, "calmarratio3y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio3yNotIn(List<BigDecimal> values) {
            addCriterion("calmarratio_3y not in", values, "calmarratio3y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio3yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("calmarratio_3y between", value1, value2, "calmarratio3y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio3yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("calmarratio_3y not between", value1, value2, "calmarratio3y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio4yIsNull() {
            addCriterion("calmarratio_4y is null");
            return (Criteria) this;
        }

        public Criteria andCalmarratio4yIsNotNull() {
            addCriterion("calmarratio_4y is not null");
            return (Criteria) this;
        }

        public Criteria andCalmarratio4yEqualTo(BigDecimal value) {
            addCriterion("calmarratio_4y =", value, "calmarratio4y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio4yNotEqualTo(BigDecimal value) {
            addCriterion("calmarratio_4y <>", value, "calmarratio4y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio4yGreaterThan(BigDecimal value) {
            addCriterion("calmarratio_4y >", value, "calmarratio4y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio4yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("calmarratio_4y >=", value, "calmarratio4y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio4yLessThan(BigDecimal value) {
            addCriterion("calmarratio_4y <", value, "calmarratio4y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio4yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("calmarratio_4y <=", value, "calmarratio4y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio4yIn(List<BigDecimal> values) {
            addCriterion("calmarratio_4y in", values, "calmarratio4y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio4yNotIn(List<BigDecimal> values) {
            addCriterion("calmarratio_4y not in", values, "calmarratio4y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio4yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("calmarratio_4y between", value1, value2, "calmarratio4y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio4yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("calmarratio_4y not between", value1, value2, "calmarratio4y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio5yIsNull() {
            addCriterion("calmarratio_5y is null");
            return (Criteria) this;
        }

        public Criteria andCalmarratio5yIsNotNull() {
            addCriterion("calmarratio_5y is not null");
            return (Criteria) this;
        }

        public Criteria andCalmarratio5yEqualTo(BigDecimal value) {
            addCriterion("calmarratio_5y =", value, "calmarratio5y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio5yNotEqualTo(BigDecimal value) {
            addCriterion("calmarratio_5y <>", value, "calmarratio5y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio5yGreaterThan(BigDecimal value) {
            addCriterion("calmarratio_5y >", value, "calmarratio5y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio5yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("calmarratio_5y >=", value, "calmarratio5y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio5yLessThan(BigDecimal value) {
            addCriterion("calmarratio_5y <", value, "calmarratio5y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio5yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("calmarratio_5y <=", value, "calmarratio5y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio5yIn(List<BigDecimal> values) {
            addCriterion("calmarratio_5y in", values, "calmarratio5y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio5yNotIn(List<BigDecimal> values) {
            addCriterion("calmarratio_5y not in", values, "calmarratio5y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio5yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("calmarratio_5y between", value1, value2, "calmarratio5y");
            return (Criteria) this;
        }

        public Criteria andCalmarratio5yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("calmarratio_5y not between", value1, value2, "calmarratio5y");
            return (Criteria) this;
        }

        public Criteria andCalmarratioIncepIsNull() {
            addCriterion("calmarratio_incep is null");
            return (Criteria) this;
        }

        public Criteria andCalmarratioIncepIsNotNull() {
            addCriterion("calmarratio_incep is not null");
            return (Criteria) this;
        }

        public Criteria andCalmarratioIncepEqualTo(BigDecimal value) {
            addCriterion("calmarratio_incep =", value, "calmarratioIncep");
            return (Criteria) this;
        }

        public Criteria andCalmarratioIncepNotEqualTo(BigDecimal value) {
            addCriterion("calmarratio_incep <>", value, "calmarratioIncep");
            return (Criteria) this;
        }

        public Criteria andCalmarratioIncepGreaterThan(BigDecimal value) {
            addCriterion("calmarratio_incep >", value, "calmarratioIncep");
            return (Criteria) this;
        }

        public Criteria andCalmarratioIncepGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("calmarratio_incep >=", value, "calmarratioIncep");
            return (Criteria) this;
        }

        public Criteria andCalmarratioIncepLessThan(BigDecimal value) {
            addCriterion("calmarratio_incep <", value, "calmarratioIncep");
            return (Criteria) this;
        }

        public Criteria andCalmarratioIncepLessThanOrEqualTo(BigDecimal value) {
            addCriterion("calmarratio_incep <=", value, "calmarratioIncep");
            return (Criteria) this;
        }

        public Criteria andCalmarratioIncepIn(List<BigDecimal> values) {
            addCriterion("calmarratio_incep in", values, "calmarratioIncep");
            return (Criteria) this;
        }

        public Criteria andCalmarratioIncepNotIn(List<BigDecimal> values) {
            addCriterion("calmarratio_incep not in", values, "calmarratioIncep");
            return (Criteria) this;
        }

        public Criteria andCalmarratioIncepBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("calmarratio_incep between", value1, value2, "calmarratioIncep");
            return (Criteria) this;
        }

        public Criteria andCalmarratioIncepNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("calmarratio_incep not between", value1, value2, "calmarratioIncep");
            return (Criteria) this;
        }

        public Criteria andOmegaratio1yIsNull() {
            addCriterion("omegaratio_1y is null");
            return (Criteria) this;
        }

        public Criteria andOmegaratio1yIsNotNull() {
            addCriterion("omegaratio_1y is not null");
            return (Criteria) this;
        }

        public Criteria andOmegaratio1yEqualTo(BigDecimal value) {
            addCriterion("omegaratio_1y =", value, "omegaratio1y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio1yNotEqualTo(BigDecimal value) {
            addCriterion("omegaratio_1y <>", value, "omegaratio1y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio1yGreaterThan(BigDecimal value) {
            addCriterion("omegaratio_1y >", value, "omegaratio1y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio1yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("omegaratio_1y >=", value, "omegaratio1y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio1yLessThan(BigDecimal value) {
            addCriterion("omegaratio_1y <", value, "omegaratio1y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio1yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("omegaratio_1y <=", value, "omegaratio1y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio1yIn(List<BigDecimal> values) {
            addCriterion("omegaratio_1y in", values, "omegaratio1y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio1yNotIn(List<BigDecimal> values) {
            addCriterion("omegaratio_1y not in", values, "omegaratio1y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio1yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("omegaratio_1y between", value1, value2, "omegaratio1y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio1yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("omegaratio_1y not between", value1, value2, "omegaratio1y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio2yIsNull() {
            addCriterion("omegaratio_2y is null");
            return (Criteria) this;
        }

        public Criteria andOmegaratio2yIsNotNull() {
            addCriterion("omegaratio_2y is not null");
            return (Criteria) this;
        }

        public Criteria andOmegaratio2yEqualTo(BigDecimal value) {
            addCriterion("omegaratio_2y =", value, "omegaratio2y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio2yNotEqualTo(BigDecimal value) {
            addCriterion("omegaratio_2y <>", value, "omegaratio2y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio2yGreaterThan(BigDecimal value) {
            addCriterion("omegaratio_2y >", value, "omegaratio2y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio2yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("omegaratio_2y >=", value, "omegaratio2y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio2yLessThan(BigDecimal value) {
            addCriterion("omegaratio_2y <", value, "omegaratio2y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio2yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("omegaratio_2y <=", value, "omegaratio2y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio2yIn(List<BigDecimal> values) {
            addCriterion("omegaratio_2y in", values, "omegaratio2y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio2yNotIn(List<BigDecimal> values) {
            addCriterion("omegaratio_2y not in", values, "omegaratio2y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio2yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("omegaratio_2y between", value1, value2, "omegaratio2y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio2yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("omegaratio_2y not between", value1, value2, "omegaratio2y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio3yIsNull() {
            addCriterion("omegaratio_3y is null");
            return (Criteria) this;
        }

        public Criteria andOmegaratio3yIsNotNull() {
            addCriterion("omegaratio_3y is not null");
            return (Criteria) this;
        }

        public Criteria andOmegaratio3yEqualTo(BigDecimal value) {
            addCriterion("omegaratio_3y =", value, "omegaratio3y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio3yNotEqualTo(BigDecimal value) {
            addCriterion("omegaratio_3y <>", value, "omegaratio3y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio3yGreaterThan(BigDecimal value) {
            addCriterion("omegaratio_3y >", value, "omegaratio3y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio3yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("omegaratio_3y >=", value, "omegaratio3y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio3yLessThan(BigDecimal value) {
            addCriterion("omegaratio_3y <", value, "omegaratio3y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio3yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("omegaratio_3y <=", value, "omegaratio3y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio3yIn(List<BigDecimal> values) {
            addCriterion("omegaratio_3y in", values, "omegaratio3y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio3yNotIn(List<BigDecimal> values) {
            addCriterion("omegaratio_3y not in", values, "omegaratio3y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio3yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("omegaratio_3y between", value1, value2, "omegaratio3y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio3yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("omegaratio_3y not between", value1, value2, "omegaratio3y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio4yIsNull() {
            addCriterion("omegaratio_4y is null");
            return (Criteria) this;
        }

        public Criteria andOmegaratio4yIsNotNull() {
            addCriterion("omegaratio_4y is not null");
            return (Criteria) this;
        }

        public Criteria andOmegaratio4yEqualTo(BigDecimal value) {
            addCriterion("omegaratio_4y =", value, "omegaratio4y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio4yNotEqualTo(BigDecimal value) {
            addCriterion("omegaratio_4y <>", value, "omegaratio4y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio4yGreaterThan(BigDecimal value) {
            addCriterion("omegaratio_4y >", value, "omegaratio4y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio4yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("omegaratio_4y >=", value, "omegaratio4y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio4yLessThan(BigDecimal value) {
            addCriterion("omegaratio_4y <", value, "omegaratio4y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio4yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("omegaratio_4y <=", value, "omegaratio4y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio4yIn(List<BigDecimal> values) {
            addCriterion("omegaratio_4y in", values, "omegaratio4y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio4yNotIn(List<BigDecimal> values) {
            addCriterion("omegaratio_4y not in", values, "omegaratio4y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio4yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("omegaratio_4y between", value1, value2, "omegaratio4y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio4yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("omegaratio_4y not between", value1, value2, "omegaratio4y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio5yIsNull() {
            addCriterion("omegaratio_5y is null");
            return (Criteria) this;
        }

        public Criteria andOmegaratio5yIsNotNull() {
            addCriterion("omegaratio_5y is not null");
            return (Criteria) this;
        }

        public Criteria andOmegaratio5yEqualTo(BigDecimal value) {
            addCriterion("omegaratio_5y =", value, "omegaratio5y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio5yNotEqualTo(BigDecimal value) {
            addCriterion("omegaratio_5y <>", value, "omegaratio5y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio5yGreaterThan(BigDecimal value) {
            addCriterion("omegaratio_5y >", value, "omegaratio5y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio5yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("omegaratio_5y >=", value, "omegaratio5y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio5yLessThan(BigDecimal value) {
            addCriterion("omegaratio_5y <", value, "omegaratio5y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio5yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("omegaratio_5y <=", value, "omegaratio5y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio5yIn(List<BigDecimal> values) {
            addCriterion("omegaratio_5y in", values, "omegaratio5y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio5yNotIn(List<BigDecimal> values) {
            addCriterion("omegaratio_5y not in", values, "omegaratio5y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio5yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("omegaratio_5y between", value1, value2, "omegaratio5y");
            return (Criteria) this;
        }

        public Criteria andOmegaratio5yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("omegaratio_5y not between", value1, value2, "omegaratio5y");
            return (Criteria) this;
        }

        public Criteria andOmegaratioIncepIsNull() {
            addCriterion("omegaratio_incep is null");
            return (Criteria) this;
        }

        public Criteria andOmegaratioIncepIsNotNull() {
            addCriterion("omegaratio_incep is not null");
            return (Criteria) this;
        }

        public Criteria andOmegaratioIncepEqualTo(BigDecimal value) {
            addCriterion("omegaratio_incep =", value, "omegaratioIncep");
            return (Criteria) this;
        }

        public Criteria andOmegaratioIncepNotEqualTo(BigDecimal value) {
            addCriterion("omegaratio_incep <>", value, "omegaratioIncep");
            return (Criteria) this;
        }

        public Criteria andOmegaratioIncepGreaterThan(BigDecimal value) {
            addCriterion("omegaratio_incep >", value, "omegaratioIncep");
            return (Criteria) this;
        }

        public Criteria andOmegaratioIncepGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("omegaratio_incep >=", value, "omegaratioIncep");
            return (Criteria) this;
        }

        public Criteria andOmegaratioIncepLessThan(BigDecimal value) {
            addCriterion("omegaratio_incep <", value, "omegaratioIncep");
            return (Criteria) this;
        }

        public Criteria andOmegaratioIncepLessThanOrEqualTo(BigDecimal value) {
            addCriterion("omegaratio_incep <=", value, "omegaratioIncep");
            return (Criteria) this;
        }

        public Criteria andOmegaratioIncepIn(List<BigDecimal> values) {
            addCriterion("omegaratio_incep in", values, "omegaratioIncep");
            return (Criteria) this;
        }

        public Criteria andOmegaratioIncepNotIn(List<BigDecimal> values) {
            addCriterion("omegaratio_incep not in", values, "omegaratioIncep");
            return (Criteria) this;
        }

        public Criteria andOmegaratioIncepBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("omegaratio_incep between", value1, value2, "omegaratioIncep");
            return (Criteria) this;
        }

        public Criteria andOmegaratioIncepNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("omegaratio_incep not between", value1, value2, "omegaratioIncep");
            return (Criteria) this;
        }

        public Criteria andKapparatio1yIsNull() {
            addCriterion("kapparatio_1y is null");
            return (Criteria) this;
        }

        public Criteria andKapparatio1yIsNotNull() {
            addCriterion("kapparatio_1y is not null");
            return (Criteria) this;
        }

        public Criteria andKapparatio1yEqualTo(BigDecimal value) {
            addCriterion("kapparatio_1y =", value, "kapparatio1y");
            return (Criteria) this;
        }

        public Criteria andKapparatio1yNotEqualTo(BigDecimal value) {
            addCriterion("kapparatio_1y <>", value, "kapparatio1y");
            return (Criteria) this;
        }

        public Criteria andKapparatio1yGreaterThan(BigDecimal value) {
            addCriterion("kapparatio_1y >", value, "kapparatio1y");
            return (Criteria) this;
        }

        public Criteria andKapparatio1yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("kapparatio_1y >=", value, "kapparatio1y");
            return (Criteria) this;
        }

        public Criteria andKapparatio1yLessThan(BigDecimal value) {
            addCriterion("kapparatio_1y <", value, "kapparatio1y");
            return (Criteria) this;
        }

        public Criteria andKapparatio1yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("kapparatio_1y <=", value, "kapparatio1y");
            return (Criteria) this;
        }

        public Criteria andKapparatio1yIn(List<BigDecimal> values) {
            addCriterion("kapparatio_1y in", values, "kapparatio1y");
            return (Criteria) this;
        }

        public Criteria andKapparatio1yNotIn(List<BigDecimal> values) {
            addCriterion("kapparatio_1y not in", values, "kapparatio1y");
            return (Criteria) this;
        }

        public Criteria andKapparatio1yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("kapparatio_1y between", value1, value2, "kapparatio1y");
            return (Criteria) this;
        }

        public Criteria andKapparatio1yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("kapparatio_1y not between", value1, value2, "kapparatio1y");
            return (Criteria) this;
        }

        public Criteria andKapparatio2yIsNull() {
            addCriterion("kapparatio_2y is null");
            return (Criteria) this;
        }

        public Criteria andKapparatio2yIsNotNull() {
            addCriterion("kapparatio_2y is not null");
            return (Criteria) this;
        }

        public Criteria andKapparatio2yEqualTo(BigDecimal value) {
            addCriterion("kapparatio_2y =", value, "kapparatio2y");
            return (Criteria) this;
        }

        public Criteria andKapparatio2yNotEqualTo(BigDecimal value) {
            addCriterion("kapparatio_2y <>", value, "kapparatio2y");
            return (Criteria) this;
        }

        public Criteria andKapparatio2yGreaterThan(BigDecimal value) {
            addCriterion("kapparatio_2y >", value, "kapparatio2y");
            return (Criteria) this;
        }

        public Criteria andKapparatio2yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("kapparatio_2y >=", value, "kapparatio2y");
            return (Criteria) this;
        }

        public Criteria andKapparatio2yLessThan(BigDecimal value) {
            addCriterion("kapparatio_2y <", value, "kapparatio2y");
            return (Criteria) this;
        }

        public Criteria andKapparatio2yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("kapparatio_2y <=", value, "kapparatio2y");
            return (Criteria) this;
        }

        public Criteria andKapparatio2yIn(List<BigDecimal> values) {
            addCriterion("kapparatio_2y in", values, "kapparatio2y");
            return (Criteria) this;
        }

        public Criteria andKapparatio2yNotIn(List<BigDecimal> values) {
            addCriterion("kapparatio_2y not in", values, "kapparatio2y");
            return (Criteria) this;
        }

        public Criteria andKapparatio2yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("kapparatio_2y between", value1, value2, "kapparatio2y");
            return (Criteria) this;
        }

        public Criteria andKapparatio2yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("kapparatio_2y not between", value1, value2, "kapparatio2y");
            return (Criteria) this;
        }

        public Criteria andKapparatio3yIsNull() {
            addCriterion("kapparatio_3y is null");
            return (Criteria) this;
        }

        public Criteria andKapparatio3yIsNotNull() {
            addCriterion("kapparatio_3y is not null");
            return (Criteria) this;
        }

        public Criteria andKapparatio3yEqualTo(BigDecimal value) {
            addCriterion("kapparatio_3y =", value, "kapparatio3y");
            return (Criteria) this;
        }

        public Criteria andKapparatio3yNotEqualTo(BigDecimal value) {
            addCriterion("kapparatio_3y <>", value, "kapparatio3y");
            return (Criteria) this;
        }

        public Criteria andKapparatio3yGreaterThan(BigDecimal value) {
            addCriterion("kapparatio_3y >", value, "kapparatio3y");
            return (Criteria) this;
        }

        public Criteria andKapparatio3yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("kapparatio_3y >=", value, "kapparatio3y");
            return (Criteria) this;
        }

        public Criteria andKapparatio3yLessThan(BigDecimal value) {
            addCriterion("kapparatio_3y <", value, "kapparatio3y");
            return (Criteria) this;
        }

        public Criteria andKapparatio3yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("kapparatio_3y <=", value, "kapparatio3y");
            return (Criteria) this;
        }

        public Criteria andKapparatio3yIn(List<BigDecimal> values) {
            addCriterion("kapparatio_3y in", values, "kapparatio3y");
            return (Criteria) this;
        }

        public Criteria andKapparatio3yNotIn(List<BigDecimal> values) {
            addCriterion("kapparatio_3y not in", values, "kapparatio3y");
            return (Criteria) this;
        }

        public Criteria andKapparatio3yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("kapparatio_3y between", value1, value2, "kapparatio3y");
            return (Criteria) this;
        }

        public Criteria andKapparatio3yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("kapparatio_3y not between", value1, value2, "kapparatio3y");
            return (Criteria) this;
        }

        public Criteria andKapparatio4yIsNull() {
            addCriterion("kapparatio_4y is null");
            return (Criteria) this;
        }

        public Criteria andKapparatio4yIsNotNull() {
            addCriterion("kapparatio_4y is not null");
            return (Criteria) this;
        }

        public Criteria andKapparatio4yEqualTo(BigDecimal value) {
            addCriterion("kapparatio_4y =", value, "kapparatio4y");
            return (Criteria) this;
        }

        public Criteria andKapparatio4yNotEqualTo(BigDecimal value) {
            addCriterion("kapparatio_4y <>", value, "kapparatio4y");
            return (Criteria) this;
        }

        public Criteria andKapparatio4yGreaterThan(BigDecimal value) {
            addCriterion("kapparatio_4y >", value, "kapparatio4y");
            return (Criteria) this;
        }

        public Criteria andKapparatio4yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("kapparatio_4y >=", value, "kapparatio4y");
            return (Criteria) this;
        }

        public Criteria andKapparatio4yLessThan(BigDecimal value) {
            addCriterion("kapparatio_4y <", value, "kapparatio4y");
            return (Criteria) this;
        }

        public Criteria andKapparatio4yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("kapparatio_4y <=", value, "kapparatio4y");
            return (Criteria) this;
        }

        public Criteria andKapparatio4yIn(List<BigDecimal> values) {
            addCriterion("kapparatio_4y in", values, "kapparatio4y");
            return (Criteria) this;
        }

        public Criteria andKapparatio4yNotIn(List<BigDecimal> values) {
            addCriterion("kapparatio_4y not in", values, "kapparatio4y");
            return (Criteria) this;
        }

        public Criteria andKapparatio4yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("kapparatio_4y between", value1, value2, "kapparatio4y");
            return (Criteria) this;
        }

        public Criteria andKapparatio4yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("kapparatio_4y not between", value1, value2, "kapparatio4y");
            return (Criteria) this;
        }

        public Criteria andKapparatio5yIsNull() {
            addCriterion("kapparatio_5y is null");
            return (Criteria) this;
        }

        public Criteria andKapparatio5yIsNotNull() {
            addCriterion("kapparatio_5y is not null");
            return (Criteria) this;
        }

        public Criteria andKapparatio5yEqualTo(BigDecimal value) {
            addCriterion("kapparatio_5y =", value, "kapparatio5y");
            return (Criteria) this;
        }

        public Criteria andKapparatio5yNotEqualTo(BigDecimal value) {
            addCriterion("kapparatio_5y <>", value, "kapparatio5y");
            return (Criteria) this;
        }

        public Criteria andKapparatio5yGreaterThan(BigDecimal value) {
            addCriterion("kapparatio_5y >", value, "kapparatio5y");
            return (Criteria) this;
        }

        public Criteria andKapparatio5yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("kapparatio_5y >=", value, "kapparatio5y");
            return (Criteria) this;
        }

        public Criteria andKapparatio5yLessThan(BigDecimal value) {
            addCriterion("kapparatio_5y <", value, "kapparatio5y");
            return (Criteria) this;
        }

        public Criteria andKapparatio5yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("kapparatio_5y <=", value, "kapparatio5y");
            return (Criteria) this;
        }

        public Criteria andKapparatio5yIn(List<BigDecimal> values) {
            addCriterion("kapparatio_5y in", values, "kapparatio5y");
            return (Criteria) this;
        }

        public Criteria andKapparatio5yNotIn(List<BigDecimal> values) {
            addCriterion("kapparatio_5y not in", values, "kapparatio5y");
            return (Criteria) this;
        }

        public Criteria andKapparatio5yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("kapparatio_5y between", value1, value2, "kapparatio5y");
            return (Criteria) this;
        }

        public Criteria andKapparatio5yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("kapparatio_5y not between", value1, value2, "kapparatio5y");
            return (Criteria) this;
        }

        public Criteria andKapparatioIncepIsNull() {
            addCriterion("kapparatio_incep is null");
            return (Criteria) this;
        }

        public Criteria andKapparatioIncepIsNotNull() {
            addCriterion("kapparatio_incep is not null");
            return (Criteria) this;
        }

        public Criteria andKapparatioIncepEqualTo(BigDecimal value) {
            addCriterion("kapparatio_incep =", value, "kapparatioIncep");
            return (Criteria) this;
        }

        public Criteria andKapparatioIncepNotEqualTo(BigDecimal value) {
            addCriterion("kapparatio_incep <>", value, "kapparatioIncep");
            return (Criteria) this;
        }

        public Criteria andKapparatioIncepGreaterThan(BigDecimal value) {
            addCriterion("kapparatio_incep >", value, "kapparatioIncep");
            return (Criteria) this;
        }

        public Criteria andKapparatioIncepGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("kapparatio_incep >=", value, "kapparatioIncep");
            return (Criteria) this;
        }

        public Criteria andKapparatioIncepLessThan(BigDecimal value) {
            addCriterion("kapparatio_incep <", value, "kapparatioIncep");
            return (Criteria) this;
        }

        public Criteria andKapparatioIncepLessThanOrEqualTo(BigDecimal value) {
            addCriterion("kapparatio_incep <=", value, "kapparatioIncep");
            return (Criteria) this;
        }

        public Criteria andKapparatioIncepIn(List<BigDecimal> values) {
            addCriterion("kapparatio_incep in", values, "kapparatioIncep");
            return (Criteria) this;
        }

        public Criteria andKapparatioIncepNotIn(List<BigDecimal> values) {
            addCriterion("kapparatio_incep not in", values, "kapparatioIncep");
            return (Criteria) this;
        }

        public Criteria andKapparatioIncepBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("kapparatio_incep between", value1, value2, "kapparatioIncep");
            return (Criteria) this;
        }

        public Criteria andKapparatioIncepNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("kapparatio_incep not between", value1, value2, "kapparatioIncep");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andDeleteTagIsNull() {
            addCriterion("delete_tag is null");
            return (Criteria) this;
        }

        public Criteria andDeleteTagIsNotNull() {
            addCriterion("delete_tag is not null");
            return (Criteria) this;
        }

        public Criteria andDeleteTagEqualTo(Integer value) {
            addCriterion("delete_tag =", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagNotEqualTo(Integer value) {
            addCriterion("delete_tag <>", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagGreaterThan(Integer value) {
            addCriterion("delete_tag >", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagGreaterThanOrEqualTo(Integer value) {
            addCriterion("delete_tag >=", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagLessThan(Integer value) {
            addCriterion("delete_tag <", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagLessThanOrEqualTo(Integer value) {
            addCriterion("delete_tag <=", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagIn(List<Integer> values) {
            addCriterion("delete_tag in", values, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagNotIn(List<Integer> values) {
            addCriterion("delete_tag not in", values, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagBetween(Integer value1, Integer value2) {
            addCriterion("delete_tag between", value1, value2, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagNotBetween(Integer value1, Integer value2) {
            addCriterion("delete_tag not between", value1, value2, "deleteTag");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}