package com.tanpu.fund.service;

import com.tanpu.common.model.Page;
import com.tanpu.common.model.Pageable;
import com.tanpu.fund.api.model.req.FundQaAskReq;
import com.tanpu.fund.api.model.resp.QAVO;

public interface FundQAService {

    /**
     * 产品QA 提问
     *
     */
    QAVO productQaAsk(FundQaAskReq fundQaAskReq);

    /**
     * 产品QA列表
     *
     * @param fundId 基金ID
     * @return
     */
    Page<QAVO> getProductQAInfo(String fundId, Pageable pageable);
}
