package com.tanpu.fund.service;

/**
 * 用户基金相关统计
 */
public interface UserFundCountService {

    /**
     * 计算用户组合基金中各基金认购份额
     *
     * @param pFundId 组合基金ID
     * @param userId 用户Id
     */
    void share(String pFundId, String userId);

    /**
     * 计算组合基金配比
     *
     * @param fundId
     */
    void matchRatio(String fundId, String userId);
}