package com.tanpu.fund.entity.generator;

import java.util.Date;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @author: zhoupeng
 * @email: zhoupeng_08@163.com
 */

/**
 * 文件描述
 */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class FileDesc {
    private String id;

    /**
     * 文件id
     */
    private String relId;

    private String createBy;

    private Date createTime;

    private String updateBy;

    private Date updateTime;

    private Integer deleteTag;

    private String info;
}