package com.tanpu.fund.entity.generator;

import java.math.BigDecimal;
import java.util.Date;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @author: zhoupeng
 * @email: zhoupeng_08@163.com
 */
/**
    * 组合基金变动历史
    */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class FundCombineInfoHistory {
    private String id;

    /**
    * 组合基金id
    */
    private String pFundId;

    /**
    * 基金id
    */
    private String fundId;

    /**
    * 变动日期
    */
    private Date changeDate;

    /**
    * 占比
    */
    private BigDecimal proportionRatio;

    /**
    * 较上次推荐持仓变动
    */
    private BigDecimal compareLast;

    private Date createTime;

    private String createBy;

    private Date updateTime;

    private String updateBy;

    private Integer deleteTag;
}