package com.tanpu.fund.entity.generator;

import java.util.Date;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
/**
    * 基金开放日赎回日
    */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class FundDate {
    private String id;

    private String fundId;

    /**
    * 1:开放日 2:临时开发日 3:赎回日
    */
    private Integer type;

    /**
    * 日期
    */
    private Date date;
}