package com.tanpu.fund.entity.generator;

import java.util.Date;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @author: zhoupeng
 * @email: zhoupeng_08@163.com
 */
/**
    * 产品解读
    */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class FundExplain {
    /**
    * 主键id
    */
    private String id;

    /**
    * 基金id
    */
    private String fundId;

    /**
    * 标题
    */
    private String title;

    /**
    * 解读内容
    */
    private String content;

    /**
    * 排序
    */
    private Integer sort;

    /**
    * 创建人
    */
    private String createBy;

    /**
    * 创建时间
    */
    private Date createTime;

    /**
    * 更新人
    */
    private String updateBy;

    /**
    * 更新时间
    */
    private Date updateTime;

    /**
    * 删除标识
    */
    private Integer deleteTag;
}