package com.tanpu.fund.entity.generator;

import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

/**
 * @author: zhoupeng
 * @email: zhoupeng_08@163.com
 */
public class FundStatusExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public FundStatusExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        protected void addCriterionForJDBCDate(String condition, Date value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value.getTime()), property);
        }

        protected void addCriterionForJDBCDate(String condition, List<Date> values, String property) {
            if (values == null || values.size() == 0) {
                throw new RuntimeException("Value list for " + property + " cannot be null or empty");
            }
            List<java.sql.Date> dateList = new ArrayList<>();
            Iterator<Date> iter = values.iterator();
            while (iter.hasNext()) {
                dateList.add(new java.sql.Date(iter.next().getTime()));
            }
            addCriterion(condition, dateList, property);
        }

        protected void addCriterionForJDBCDate(String condition, Date value1, Date value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value1.getTime()), new java.sql.Date(value2.getTime()), property);
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andFundStatusIsNull() {
            addCriterion("fund_status is null");
            return (Criteria) this;
        }

        public Criteria andFundStatusIsNotNull() {
            addCriterion("fund_status is not null");
            return (Criteria) this;
        }

        public Criteria andFundStatusEqualTo(String value) {
            addCriterion("fund_status =", value, "fundStatus");
            return (Criteria) this;
        }

        public Criteria andFundStatusNotEqualTo(String value) {
            addCriterion("fund_status <>", value, "fundStatus");
            return (Criteria) this;
        }

        public Criteria andFundStatusGreaterThan(String value) {
            addCriterion("fund_status >", value, "fundStatus");
            return (Criteria) this;
        }

        public Criteria andFundStatusGreaterThanOrEqualTo(String value) {
            addCriterion("fund_status >=", value, "fundStatus");
            return (Criteria) this;
        }

        public Criteria andFundStatusLessThan(String value) {
            addCriterion("fund_status <", value, "fundStatus");
            return (Criteria) this;
        }

        public Criteria andFundStatusLessThanOrEqualTo(String value) {
            addCriterion("fund_status <=", value, "fundStatus");
            return (Criteria) this;
        }

        public Criteria andFundStatusLike(String value) {
            addCriterion("fund_status like", value, "fundStatus");
            return (Criteria) this;
        }

        public Criteria andFundStatusNotLike(String value) {
            addCriterion("fund_status not like", value, "fundStatus");
            return (Criteria) this;
        }

        public Criteria andFundStatusIn(List<String> values) {
            addCriterion("fund_status in", values, "fundStatus");
            return (Criteria) this;
        }

        public Criteria andFundStatusNotIn(List<String> values) {
            addCriterion("fund_status not in", values, "fundStatus");
            return (Criteria) this;
        }

        public Criteria andFundStatusBetween(String value1, String value2) {
            addCriterion("fund_status between", value1, value2, "fundStatus");
            return (Criteria) this;
        }

        public Criteria andFundStatusNotBetween(String value1, String value2) {
            addCriterion("fund_status not between", value1, value2, "fundStatus");
            return (Criteria) this;
        }

        public Criteria andStatusStartDateIsNull() {
            addCriterion("status_start_date is null");
            return (Criteria) this;
        }

        public Criteria andStatusStartDateIsNotNull() {
            addCriterion("status_start_date is not null");
            return (Criteria) this;
        }

        public Criteria andStatusStartDateEqualTo(Date value) {
            addCriterionForJDBCDate("status_start_date =", value, "statusStartDate");
            return (Criteria) this;
        }

        public Criteria andStatusStartDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("status_start_date <>", value, "statusStartDate");
            return (Criteria) this;
        }

        public Criteria andStatusStartDateGreaterThan(Date value) {
            addCriterionForJDBCDate("status_start_date >", value, "statusStartDate");
            return (Criteria) this;
        }

        public Criteria andStatusStartDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("status_start_date >=", value, "statusStartDate");
            return (Criteria) this;
        }

        public Criteria andStatusStartDateLessThan(Date value) {
            addCriterionForJDBCDate("status_start_date <", value, "statusStartDate");
            return (Criteria) this;
        }

        public Criteria andStatusStartDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("status_start_date <=", value, "statusStartDate");
            return (Criteria) this;
        }

        public Criteria andStatusStartDateIn(List<Date> values) {
            addCriterionForJDBCDate("status_start_date in", values, "statusStartDate");
            return (Criteria) this;
        }

        public Criteria andStatusStartDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("status_start_date not in", values, "statusStartDate");
            return (Criteria) this;
        }

        public Criteria andStatusStartDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("status_start_date between", value1, value2, "statusStartDate");
            return (Criteria) this;
        }

        public Criteria andStatusStartDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("status_start_date not between", value1, value2, "statusStartDate");
            return (Criteria) this;
        }

        public Criteria andStatusEndDateIsNull() {
            addCriterion("status_end_date is null");
            return (Criteria) this;
        }

        public Criteria andStatusEndDateIsNotNull() {
            addCriterion("status_end_date is not null");
            return (Criteria) this;
        }

        public Criteria andStatusEndDateEqualTo(Date value) {
            addCriterionForJDBCDate("status_end_date =", value, "statusEndDate");
            return (Criteria) this;
        }

        public Criteria andStatusEndDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("status_end_date <>", value, "statusEndDate");
            return (Criteria) this;
        }

        public Criteria andStatusEndDateGreaterThan(Date value) {
            addCriterionForJDBCDate("status_end_date >", value, "statusEndDate");
            return (Criteria) this;
        }

        public Criteria andStatusEndDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("status_end_date >=", value, "statusEndDate");
            return (Criteria) this;
        }

        public Criteria andStatusEndDateLessThan(Date value) {
            addCriterionForJDBCDate("status_end_date <", value, "statusEndDate");
            return (Criteria) this;
        }

        public Criteria andStatusEndDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("status_end_date <=", value, "statusEndDate");
            return (Criteria) this;
        }

        public Criteria andStatusEndDateIn(List<Date> values) {
            addCriterionForJDBCDate("status_end_date in", values, "statusEndDate");
            return (Criteria) this;
        }

        public Criteria andStatusEndDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("status_end_date not in", values, "statusEndDate");
            return (Criteria) this;
        }

        public Criteria andStatusEndDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("status_end_date between", value1, value2, "statusEndDate");
            return (Criteria) this;
        }

        public Criteria andStatusEndDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("status_end_date not between", value1, value2, "statusEndDate");
            return (Criteria) this;
        }

        public Criteria andLiquidateDateIsNull() {
            addCriterion("liquidate_date is null");
            return (Criteria) this;
        }

        public Criteria andLiquidateDateIsNotNull() {
            addCriterion("liquidate_date is not null");
            return (Criteria) this;
        }

        public Criteria andLiquidateDateEqualTo(Date value) {
            addCriterionForJDBCDate("liquidate_date =", value, "liquidateDate");
            return (Criteria) this;
        }

        public Criteria andLiquidateDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("liquidate_date <>", value, "liquidateDate");
            return (Criteria) this;
        }

        public Criteria andLiquidateDateGreaterThan(Date value) {
            addCriterionForJDBCDate("liquidate_date >", value, "liquidateDate");
            return (Criteria) this;
        }

        public Criteria andLiquidateDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("liquidate_date >=", value, "liquidateDate");
            return (Criteria) this;
        }

        public Criteria andLiquidateDateLessThan(Date value) {
            addCriterionForJDBCDate("liquidate_date <", value, "liquidateDate");
            return (Criteria) this;
        }

        public Criteria andLiquidateDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("liquidate_date <=", value, "liquidateDate");
            return (Criteria) this;
        }

        public Criteria andLiquidateDateIn(List<Date> values) {
            addCriterionForJDBCDate("liquidate_date in", values, "liquidateDate");
            return (Criteria) this;
        }

        public Criteria andLiquidateDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("liquidate_date not in", values, "liquidateDate");
            return (Criteria) this;
        }

        public Criteria andLiquidateDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("liquidate_date between", value1, value2, "liquidateDate");
            return (Criteria) this;
        }

        public Criteria andLiquidateDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("liquidate_date not between", value1, value2, "liquidateDate");
            return (Criteria) this;
        }

        public Criteria andCreateByIsNull() {
            addCriterion("create_by is null");
            return (Criteria) this;
        }

        public Criteria andCreateByIsNotNull() {
            addCriterion("create_by is not null");
            return (Criteria) this;
        }

        public Criteria andCreateByEqualTo(String value) {
            addCriterion("create_by =", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotEqualTo(String value) {
            addCriterion("create_by <>", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByGreaterThan(String value) {
            addCriterion("create_by >", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByGreaterThanOrEqualTo(String value) {
            addCriterion("create_by >=", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByLessThan(String value) {
            addCriterion("create_by <", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByLessThanOrEqualTo(String value) {
            addCriterion("create_by <=", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByLike(String value) {
            addCriterion("create_by like", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotLike(String value) {
            addCriterion("create_by not like", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByIn(List<String> values) {
            addCriterion("create_by in", values, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotIn(List<String> values) {
            addCriterion("create_by not in", values, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByBetween(String value1, String value2) {
            addCriterion("create_by between", value1, value2, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotBetween(String value1, String value2) {
            addCriterion("create_by not between", value1, value2, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andUpdateByIsNull() {
            addCriterion("update_by is null");
            return (Criteria) this;
        }

        public Criteria andUpdateByIsNotNull() {
            addCriterion("update_by is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateByEqualTo(String value) {
            addCriterion("update_by =", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotEqualTo(String value) {
            addCriterion("update_by <>", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByGreaterThan(String value) {
            addCriterion("update_by >", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByGreaterThanOrEqualTo(String value) {
            addCriterion("update_by >=", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByLessThan(String value) {
            addCriterion("update_by <", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByLessThanOrEqualTo(String value) {
            addCriterion("update_by <=", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByLike(String value) {
            addCriterion("update_by like", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotLike(String value) {
            addCriterion("update_by not like", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByIn(List<String> values) {
            addCriterion("update_by in", values, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotIn(List<String> values) {
            addCriterion("update_by not in", values, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByBetween(String value1, String value2) {
            addCriterion("update_by between", value1, value2, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotBetween(String value1, String value2) {
            addCriterion("update_by not between", value1, value2, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andDeleteTagIsNull() {
            addCriterion("delete_tag is null");
            return (Criteria) this;
        }

        public Criteria andDeleteTagIsNotNull() {
            addCriterion("delete_tag is not null");
            return (Criteria) this;
        }

        public Criteria andDeleteTagEqualTo(Byte value) {
            addCriterion("delete_tag =", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagNotEqualTo(Byte value) {
            addCriterion("delete_tag <>", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagGreaterThan(Byte value) {
            addCriterion("delete_tag >", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagGreaterThanOrEqualTo(Byte value) {
            addCriterion("delete_tag >=", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagLessThan(Byte value) {
            addCriterion("delete_tag <", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagLessThanOrEqualTo(Byte value) {
            addCriterion("delete_tag <=", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagIn(List<Byte> values) {
            addCriterion("delete_tag in", values, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagNotIn(List<Byte> values) {
            addCriterion("delete_tag not in", values, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagBetween(Byte value1, Byte value2) {
            addCriterion("delete_tag between", value1, value2, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagNotBetween(Byte value1, Byte value2) {
            addCriterion("delete_tag not between", value1, value2, "deleteTag");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}