package com.tanpu.fund.service;

import com.tanpu.common.model.Page;
import com.tanpu.common.model.Pageable;
import com.tanpu.fund.api.model.resp.FundGroupVO;
import com.tanpu.fund.api.model.resp.FundSetListVO;

public interface FundCombineInfoService {

    /**
     * 组合基金列表查询
     *
     * @param strategyType 策略类型
     * @param page 分页
     * @return
     */
    Page<FundSetListVO> queryFundCombines(Integer strategyType, Pageable page);

    /**
     * 查询组合基金详情
     *
     * @param id 基金ID
     * @return
     */
    FundGroupVO detail(String id);
}
