package com.tanpu.fund.service;

import com.tanpu.fund.api.model.resp.TrackPositionVO;

import java.util.List;

public interface FundHistoryHoldService {

    /**
     * 基金历史变动日期集合
     *
     * @param id
     * @return
     */
    List<Long> getTrackPositionDates(String id);

    /**
     * 用户基金历史持仓
     *
     * @param id
     * @return
     */
    TrackPositionVO getTrackPositionDetail(String id, Long date);
}
