package com.tanpu.fund.service.impl;

import cn.hutool.poi.excel.ExcelReader;
import cn.hutool.poi.excel.ExcelUtil;
import com.google.common.collect.Lists;
import com.tanpu.common.model.product.resp.Net;
import com.tanpu.fund.service.ExcelHandler;
import org.springframework.util.CollectionUtils;

import javax.annotation.Resource;
import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

/**
 * @author: zhoupeng
 * @email: zhoupeng_08@163.com
 */
public class ExcelHandlerImpl implements ExcelHandler {

    @Resource
    private FundInfoMapper fundInfoMapper;

    @Resource
    private FundNavMapper fundNavMapper;


    @Override
    public void netExcelAnalysis(String url) {

        ExcelReader reader = ExcelUtil.getReader(url);
        List<List<Object>> readAll = reader.read();

        if (!CollectionUtils.isEmpty(readAll)) {

            int rowSize = readAll.size();


            int colSize = readAll.get(0).size();

            Map<String, List<Net>> allFund = new LinkedHashMap<>(rowSize);

            List<String> keyList = null;

            int row = 0;
            while (row < rowSize) {

                if (row == 0) {
                    List<Object> objects = readAll.get(0);
                    objects.remove(0);
                    objects.forEach(s -> allFund.put(s.toString(), new LinkedList<>()));

                    row++;
                    continue;
                } else if (row == 1) {
                    row++;
                    continue;
                }

                if (CollectionUtils.isEmpty(keyList)) {
                    keyList = Lists.newLinkedList(allFund.keySet());
                }

//                List<Object> list = readAll.get(row);
//                String dateStr = DateUtil.format(DateUtil.parse(list.get(0).toString()), DatePattern.NORM_DATE_PATTERN);
//                for (int col = 1; col < colSize; col++) {
//                    if (!StringUtils.isEmpty(list.get(col))) {
//                        allFund.get(keyList.get(col - 1)).add(new Net(dateStr, list.get(col).toString()));
//                    }
//                }
                row++;
            }

            /**
             * 1. 如果存在净值进行逻辑删除
             * 2. 将数据存入净值表
             */
//            keyList.stream().map(s->{
//                List<Net> nets = allFund.get(s);
//                this.fundNavMapper.selectByExample()
//            })

        }
    }
}
