//package com.tanpu.product.service.impl;
//
//import com.tanpu.common.enums.Constant;
//import com.tanpu.common.utils.DateUtils;
//import com.tanpu.product.entity.generator.*;
//import com.tanpu.product.enums.ProDisFreEnums;
//import com.tanpu.product.mapper.generator.FundNavMapper;
//import com.tanpu.product.mapper.generator.FundProfitRateMapper;
//import com.tanpu.product.service.FundCountService;
//import com.tanpu.product.utils.FormulaToFundUtil;
//import org.apache.commons.lang3.StringUtils;
//import org.apache.ibatis.jdbc.SQL;
//import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.jdbc.core.namedparam.BeanPropertySqlParameterSource;
//import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
//import org.springframework.jdbc.core.namedparam.SqlParameterSource;
//import org.springframework.jdbc.core.namedparam.SqlParameterSourceUtils;
//import org.springframework.stereotype.Service;
//
//import javax.annotation.Resource;
//import java.math.BigDecimal;
//import java.time.LocalDate;
//import java.time.format.DateTimeFormatter;
//import java.util.*;
//import java.util.stream.Collectors;
//
//@Service
//public class FundCountServiceImpl implements FundCountService {
//
//    @Resource
//    private FundNavMapper fundNavMapper;
//    @Autowired
//    private NamedParameterJdbcTemplate namedParameterJdbcTemplate;
//    @Resource
//    private FundProfitRateMapper fundProfitRateMapper;
//
//    @Override
////    @Async("asyncTaskExecutor")
//    public void sectionProfitRate(int proDisFre, Date startDate, Date endDate, List<String> fundList) {
//
////        Date startDate = null, endDate = null;
////
////        if (proDisFre == ProDisFreEnums.Day.getType()) {
////
////            startDate = DateUtils.getDayStartTime(DateUtils.getBefOrAfDay(new Date(), -1));
////            endDate = DateUtils.getDayEndTime(new Date());
////
////        } else if (proDisFre == ProDisFreEnums.Week.getType()) {
////
//////            startDate = DateUtils.getBeginDayOfLastWeek();
//////            endDate = DateUtils.getEndDayOfWeek();
////
////            startDate = DateUtils.string2date("2020-07-24");
////            endDate =  DateUtils.string2date("2020-07-31");
////
////        } else if (proDisFre == ProDisFreEnums.Month.getType()) {
////
////            startDate = DateUtils.string2date("2020-07-01");
////            endDate = DateUtils.string2date("2020-07-31");
////
////        }
//
//        //基金净值
//        FundNavExample example = new FundNavExample();
//        example.createCriteria().andPriceDateBetween(startDate, endDate).andFundIdIn(fundList);
//        example.setOrderByClause(FundNav.Column.priceDate.getEscapedColumnName() + " asc");
//        List<FundNav> curFundNavs = fundNavMapper.selectByExample(example);
//
//        Set<String> fundIdSets = curFundNavs.stream().map(FundNav::getFundId).collect(Collectors.toSet());
//
//        List<FundProfitRate> list = new ArrayList<>(fundIdSets.size());
//        for (String fundId : fundIdSets) {
//            FundProfitRate p = new FundProfitRate();
//            p.setId(fundId + LocalDate.now().format(DateTimeFormatter.ofPattern("yyyyMMdd")));
//            p.setFundId(fundId);
//            p.setFpType(proDisFre);
//
//            List<FundNav> fundNavList = curFundNavs.stream().filter(item -> StringUtils.equals(item.getFundId(), fundId))
//                    .collect(Collectors.toList());
//
//            fundNavList.sort(Comparator.comparing(FundNav::getPriceDate));
//
//            //基金ID + 计算截止日期作为 + 类型 唯一ID
//            {
//                Date priceDate = fundNavList.get(fundNavList.size() - 1).getPriceDate();
//                p.setFpDate(priceDate);
//
//                String yyyyMMdd = DateUtils.formatCus(priceDate, "yyyyMMdd");
//                p.setId(fundId + yyyyMMdd + proDisFre);
//            }
//
//            {
//                BigDecimal nav1 = fundNavList.get(0).getNav();
//                BigDecimal nav2 = fundNavList.get(fundNavList.size() - 1).getNav();
//
//                BigDecimal profitRate = FormulaToFundUtil.profitRate(nav1, nav2);
//
//                p.setFpProfitRate(profitRate);
//            }
//            p.setCreateTime(new Date());
//            p.setDeleteTag(Constant.ZERO_NUM);
//            list.add(p);
//        }
//
//        SQL insertSql = new SQL().INSERT_INTO(FundProfitRate.TABLE_NAME)
//                .INTO_COLUMNS(
//                        FundProfitRate.Column.id.getEscapedColumnName(),
//                        FundProfitRate.Column.fundId.getEscapedColumnName(),
//                        FundProfitRate.Column.fpDate.getEscapedColumnName(),
//                        FundProfitRate.Column.fpType.getEscapedColumnName(),
//                        FundProfitRate.Column.fpProfitRate.getEscapedColumnName(),
//                        FundProfitRate.Column.createTime.getEscapedColumnName(),
//                        FundProfitRate.Column.deleteTag.getEscapedColumnName()
//                ).INTO_VALUES(
//                        ":" + FundProfitRate.Column.id.getJavaProperty(),
//                        ":" + FundProfitRate.Column.fundId.getJavaProperty(),
//                        ":" + FundProfitRate.Column.fpDate.getJavaProperty(),
//                        ":" + FundProfitRate.Column.fpType.getJavaProperty(),
//                        ":" + FundProfitRate.Column.fpProfitRate.getJavaProperty(),
//                        ":" + FundProfitRate.Column.createTime.getJavaProperty(),
//                        ":" + FundProfitRate.Column.deleteTag.getJavaProperty()
//                );
//
//        //存在即更新
//        StringBuffer updateSql = new StringBuffer()
//                .append(" ON DUPLICATE KEY UPDATE ")
//                .append(FundProfitRate.Column.fundId.getEscapedColumnName() + "=:" + FundProfitRate.Column.fundId.getJavaProperty() + ", ")
//                .append(FundProfitRate.Column.fpDate.getEscapedColumnName() + "=:" + FundProfitRate.Column.fpDate.getJavaProperty() + ", ")
//                .append(FundProfitRate.Column.fpType.getEscapedColumnName() + "=:" + FundProfitRate.Column.fpType.getJavaProperty() + ", ")
//                .append(FundProfitRate.Column.fpProfitRate.getEscapedColumnName() + "=:" + FundProfitRate.Column.fpProfitRate.getJavaProperty() + ", ")
//                .append(FundProfitRate.Column.updateTime.getEscapedColumnName() + "=:" + FundProfitRate.Column.createTime.getJavaProperty() + ", ")
//                .append(FundProfitRate.Column.deleteTag.getEscapedColumnName() + "=:" + FundProfitRate.Column.deleteTag.getJavaProperty());
//
//        String sql = insertSql.toString() + updateSql.toString();
//
//        namedParameterJdbcTemplate.batchUpdate(sql, SqlParameterSourceUtils.createBatch(list));
//    }
//
//    @Override
//    public void sectionProfitRate(int proDisFre, Date startDate, Date endDate, String fundId) {
//        //基金净值
//        FundNavExample example = new FundNavExample();
//        example.createCriteria().andPriceDateBetween(startDate, endDate).andFundIdEqualTo(fundId);
//        example.setOrderByClause(FundNav.Column.priceDate.getEscapedColumnName() + " asc");
//        List<FundNav> curFundNavs = fundNavMapper.selectByExample(example);
//
//        FundProfitRate p = new FundProfitRate();
//        p.setId(fundId + LocalDate.now().format(DateTimeFormatter.ofPattern("yyyyMMdd")));
//        p.setFundId(fundId);
//        p.setFpType(proDisFre);
//
//        List<FundNav> fundNavList = curFundNavs.stream().filter(item -> StringUtils.equals(item.getFundId(), fundId))
//                .collect(Collectors.toList());
//
//        fundNavList.sort(Comparator.comparing(FundNav::getPriceDate));
//
//        //基金ID + 计算截止日期作为 + 类型 唯一ID
//        {
//            Date priceDate = fundNavList.get(fundNavList.size() - 1).getPriceDate();
//            p.setFpDate(priceDate);
//
//            p.setFpYear(Integer.valueOf(DateUtils.formatCus(priceDate, "yyyy")));
//            p.setFpMonth(Integer.valueOf(DateUtils.formatCus(priceDate, "MM")));
//
//            String yyyyMMdd = DateUtils.formatCus(priceDate, "yyyyMMdd");
//            p.setId(fundId + yyyyMMdd + proDisFre);
//        }
//
//        {
//            BigDecimal nav1 = fundNavList.get(0).getNav();
//            BigDecimal nav2 = fundNavList.get(fundNavList.size() - 1).getNav();
//
//            BigDecimal profitRate = FormulaToFundUtil.profitRate(nav1, nav2);
//
//            p.setFpProfitRate(profitRate);
//        }
//        p.setCreateTime(new Date());
//        p.setDeleteTag(Constant.ZERO_NUM);
//
//        SQL insertSql = new SQL().INSERT_INTO(FundProfitRate.TABLE_NAME)
//                .INTO_COLUMNS(
//                        FundProfitRate.Column.id.getEscapedColumnName(),
//                        FundProfitRate.Column.fundId.getEscapedColumnName(),
//                        FundProfitRate.Column.fpYear.getEscapedColumnName(),
//                        FundProfitRate.Column.fpMonth.getEscapedColumnName(),
//                        FundProfitRate.Column.fpDate.getEscapedColumnName(),
//                        FundProfitRate.Column.fpType.getEscapedColumnName(),
//                        FundProfitRate.Column.fpProfitRate.getEscapedColumnName(),
//                        FundProfitRate.Column.createTime.getEscapedColumnName(),
//                        FundProfitRate.Column.deleteTag.getEscapedColumnName()
//                ).INTO_VALUES(
//                        ":" + FundProfitRate.Column.id.getJavaProperty(),
//                        ":" + FundProfitRate.Column.fundId.getJavaProperty(),
//                        ":" + FundProfitRate.Column.fpYear.getJavaProperty(),
//                        ":" + FundProfitRate.Column.fpMonth.getJavaProperty(),
//                        ":" + FundProfitRate.Column.fpDate.getJavaProperty(),
//                        ":" + FundProfitRate.Column.fpType.getJavaProperty(),
//                        ":" + FundProfitRate.Column.fpProfitRate.getJavaProperty(),
//                        ":" + FundProfitRate.Column.createTime.getJavaProperty(),
//                        ":" + FundProfitRate.Column.deleteTag.getJavaProperty()
//                );
//
//        //存在即更新
//        StringBuffer updateSql = new StringBuffer()
//                .append(" ON DUPLICATE KEY UPDATE ")
//                .append(FundProfitRate.Column.fundId.getEscapedColumnName() + "=:" + FundProfitRate.Column.fundId.getJavaProperty() + ", ")
//                .append(FundProfitRate.Column.fpYear.getEscapedColumnName() + "=:" + FundProfitRate.Column.fpYear.getJavaProperty() + ", ")
//                .append(FundProfitRate.Column.fpMonth.getEscapedColumnName() + "=:" + FundProfitRate.Column.fpMonth.getJavaProperty() + ", ")
//                .append(FundProfitRate.Column.fpDate.getEscapedColumnName() + "=:" + FundProfitRate.Column.fpDate.getJavaProperty() + ", ")
//                .append(FundProfitRate.Column.fpType.getEscapedColumnName() + "=:" + FundProfitRate.Column.fpType.getJavaProperty() + ", ")
//                .append(FundProfitRate.Column.fpProfitRate.getEscapedColumnName() + "=:" + FundProfitRate.Column.fpProfitRate.getJavaProperty() + ", ")
//                .append(FundProfitRate.Column.updateTime.getEscapedColumnName() + "=:" + FundProfitRate.Column.createTime.getJavaProperty() + ", ")
//                .append(FundProfitRate.Column.deleteTag.getEscapedColumnName() + "=:" + FundProfitRate.Column.deleteTag.getJavaProperty());
//
//        String sql = insertSql.toString() + updateSql.toString();
//
//        SqlParameterSource sqlParameterSource = new BeanPropertySqlParameterSource(p);
//        namedParameterJdbcTemplate.update(sql, sqlParameterSource);
//    }
//
//    @Override
//    public void annualRate(String fundId, int proDisFre) {
//
//        //查询基金
//        FundProfitRateExample example = new FundProfitRateExample();
//        example.createCriteria()
//                .andFundIdEqualTo(fundId)
//                .andFpTypeEqualTo(proDisFre)
//                .andDeleteTagEqualTo(Constant.ZERO_NUM);
//        example.setOrderByClause(FundProfitRate.Column.fpDate + " asc");
//        List<FundProfitRate> list = fundProfitRateMapper.selectByExample(example);
//
//        //截止日期
//        Date minDate = list.get(0).getFpDate();
//        Date endDate = list.get(list.size() - 1).getFpDate();
//
//        //计算当前基金满几年
//        int setYear = DateUtils.daysBetween(minDate, endDate) / 365;
//
//        if (setYear <= 0) {
//            return;
//        } else if (setYear > 5) {
//            //只计算最近5年
//            setYear = 5;
//        }
//
//        FundRiskStats p = new FundRiskStats();
//        p.setId(fundId);
//        p.setFundId(fundId);
//        p.setEndDate(endDate);
//
//        //计算近5年的年化波动率
//        {
//
//            for (int i = 1; i < setYear; i++) {
//                Date befOrAfDay = annualStartDate(proDisFre, endDate, i);
//                List<FundProfitRate> collect = list.stream()
//                        .filter(item -> DateUtils.daysBetween(befOrAfDay, item.getFpDate()) >= 0 && DateUtils.daysBetween(endDate, item.getFpDate()) <= 0)
//                        .collect(Collectors.toList());
//
//                List<Double> doubleList = list.stream().map(item -> item.getFpProfitRate().doubleValue()).collect(Collectors.toList());
//                BigDecimal annual = FormulaToFundUtil.annual(doubleList);
//                if (i == 1) {
//                    p.setStddev1y(annual);
//                } else if (i == 2) {
//                    p.setStddev2y(annual);
//                } else if (i == 3) {
//                    p.setStddev3y(annual);
//                } else if (i == 4) {
//                    p.setStddev4y(annual);
//                } else {
//                    p.setStddev5y(annual);
//                }
//            }
//        }
//
//        //计算成立以来的年化波动率
//        {
//
//            List<Double> doubleList = list.stream().map(item -> item.getFpProfitRate().doubleValue()).collect(Collectors.toList());
//            BigDecimal annual = FormulaToFundUtil.annual(doubleList);
//            p.setStddevIncep(annual);
//        }
//
//        p.setCreateTime(new Date());
//        p.setDeleteTag(Constant.ZERO_NUM);
//
//        SQL insertSql = new SQL().INSERT_INTO(FundRiskStats.TABLE_NAME)
//                .INTO_COLUMNS(
//                        FundRiskStats.Column.id.getEscapedColumnName(),
//                        FundRiskStats.Column.endDate.getEscapedColumnName(),
//                        FundRiskStats.Column.stddev1y.getEscapedColumnName(),
//                        FundRiskStats.Column.stddev2y.getEscapedColumnName(),
//                        FundRiskStats.Column.stddev3y.getEscapedColumnName(),
//                        FundRiskStats.Column.stddev4y.getEscapedColumnName(),
//                        FundRiskStats.Column.stddev5y.getEscapedColumnName(),
//                        FundRiskStats.Column.stddevIncep.getEscapedColumnName(),
//                        FundRiskStats.Column.createTime.getEscapedColumnName(),
//                        FundRiskStats.Column.deleteTag.getEscapedColumnName()
//                ).INTO_VALUES(
//                        ":" + FundRiskStats.Column.id.getJavaProperty(),
//                        ":" + FundRiskStats.Column.endDate.getJavaProperty(),
//                        ":" + FundRiskStats.Column.stddev1y.getJavaProperty(),
//                        ":" + FundRiskStats.Column.stddev2y.getJavaProperty(),
//                        ":" + FundRiskStats.Column.stddev3y.getJavaProperty(),
//                        ":" + FundRiskStats.Column.stddev4y.getJavaProperty(),
//                        ":" + FundRiskStats.Column.stddev5y.getJavaProperty(),
//                        ":" + FundRiskStats.Column.stddevIncep.getJavaProperty(),
//                        ":" + FundRiskStats.Column.createTime.getJavaProperty(),
//                        ":" + FundRiskStats.Column.deleteTag.getJavaProperty()
//                );
//
//        StringBuffer updateSql = new StringBuffer()
//                .append(" ON DUPLICATE KEY UPDATE ")
//                .append(FundRiskStats.Column.endDate.getEscapedColumnName() + "= :" + FundRiskStats.Column.endDate.getJavaProperty())
//                .append(FundRiskStats.Column.stddev1y.getEscapedColumnName() + "= :" + FundRiskStats.Column.stddev1y.getJavaProperty())
//                .append(FundRiskStats.Column.stddev2y.getEscapedColumnName() + "= :" + FundRiskStats.Column.stddev2y.getJavaProperty())
//                .append(FundRiskStats.Column.stddev3y.getEscapedColumnName() + "= :" + FundRiskStats.Column.stddev3y.getJavaProperty())
//                .append(FundRiskStats.Column.stddev4y.getEscapedColumnName() + "= :" + FundRiskStats.Column.stddev4y.getJavaProperty())
//                .append(FundRiskStats.Column.stddev5y.getEscapedColumnName() + "= :" + FundRiskStats.Column.stddev5y.getJavaProperty())
//                .append(FundRiskStats.Column.stddevIncep.getEscapedColumnName() + "= :" + FundRiskStats.Column.stddevIncep.getJavaProperty())
//                .append(FundRiskStats.Column.updateTime.getEscapedColumnName() + "= :" + FundRiskStats.Column.createTime.getJavaProperty());
//
//        String sql = insertSql + updateSql.toString();
//        SqlParameterSource sqlParameterSource = new BeanPropertySqlParameterSource(p);
//        namedParameterJdbcTemplate.update(sql, sqlParameterSource);
//    }
//
//    @Override
//    public void retracement(String fundId) {
//        //查询基金净值
//        FundNavExample example = new FundNavExample();
//        example.createCriteria().andFundIdEqualTo(fundId).andDeleteTagEqualTo(Constant.ZERO_NUM);
//        example.setOrderByClause(FundNav.Column.priceDate.getEscapedColumnName() + " asc");
//
//        List<FundNav> fundNavs = fundNavMapper.selectByExample(example);
//        Date minDate = fundNavs.get(0).getPriceDate();
//        Date endDate = fundNavs.get(fundNavs.size() - 1).getPriceDate();
//
//        int years = sectionYears(minDate, endDate);
//        if (years == 0) {
//            return;
//        }
//
//        if (years <= 0) {
//            return;
//        } else if (years > 5) {
//            //只计算最近5年
//            years = 5;
//        }
//
//        FundRiskStats p = new FundRiskStats();
//        p.setId(fundId);
//        p.setFundId(fundId);
//        p.setEndDate(endDate);
//
//        //计算近N年的最大回撤 最多取近5年
//        for (int i = 0; i < years; i++) {
//            Date yearDate = DateUtils.getAfterYears(endDate, -i);
//
//            List<BigDecimal> collect = fundNavs.stream()
//                    .filter(item -> DateUtils.daysBetween(yearDate, item.getPriceDate()) >= 0)
//                    .map(FundNav::getNav)
//                    .collect(Collectors.toList());
//
//            List<Double> navList = collect.stream().map(BigDecimal::doubleValue).collect(Collectors.toList());
//            BigDecimal annual = FormulaToFundUtil.annual(navList);
//
//            if (i == 1) {
//                p.setMaxdrawdown1y(annual);
//            } else if (i == 2) {
//                p.setMaxdrawdown2y(annual);
//            } else if (i == 3) {
//                p.setMaxdrawdown3y(annual);
//            } else if (i == 4) {
//                p.setMaxdrawdown4y(annual);
//            } else if (i == 5) {
//                p.setMaxdrawdown5y(annual);
//            }
//        }
//
//        //成立以来的最大回撤
//        {
//            List<Double> navList = fundNavs.stream().map(item -> item.getNav().doubleValue()).collect(Collectors.toList());
//            BigDecimal annual = FormulaToFundUtil.annual(navList);
//
//            p.setMaxdrawdownIncep(annual);
//        }
//
//        p.setCreateTime(new Date());
//        p.setDeleteTag(Constant.ZERO_NUM);
//
//        SQL insertSql = new SQL().INSERT_INTO(FundRiskStats.TABLE_NAME)
//                .INTO_COLUMNS(
//                        FundRiskStats.Column.id.getEscapedColumnName(),
//                        FundRiskStats.Column.endDate.getEscapedColumnName(),
//                        FundRiskStats.Column.maxdrawdown1y.getEscapedColumnName(),
//                        FundRiskStats.Column.maxdrawdown2y.getEscapedColumnName(),
//                        FundRiskStats.Column.maxdrawdown3y.getEscapedColumnName(),
//                        FundRiskStats.Column.maxdrawdown4y.getEscapedColumnName(),
//                        FundRiskStats.Column.maxdrawdown5y.getEscapedColumnName(),
//                        FundRiskStats.Column.maxdrawdownIncep.getEscapedColumnName(),
//                        FundRiskStats.Column.createTime.getEscapedColumnName(),
//                        FundRiskStats.Column.deleteTag.getEscapedColumnName()
//                ).INTO_VALUES(
//                        ":" + FundRiskStats.Column.id.getJavaProperty(),
//                        ":" + FundRiskStats.Column.endDate.getJavaProperty(),
//                        ":" + FundRiskStats.Column.maxdrawdown1y.getJavaProperty(),
//                        ":" + FundRiskStats.Column.maxdrawdown2y.getJavaProperty(),
//                        ":" + FundRiskStats.Column.maxdrawdown3y.getJavaProperty(),
//                        ":" + FundRiskStats.Column.maxdrawdown4y.getJavaProperty(),
//                        ":" + FundRiskStats.Column.maxdrawdown5y.getJavaProperty(),
//                        ":" + FundRiskStats.Column.maxdrawdownIncep.getJavaProperty(),
//                        ":" + FundRiskStats.Column.createTime.getJavaProperty(),
//                        ":" + FundRiskStats.Column.deleteTag.getJavaProperty()
//                );
//
//        StringBuffer updateSql = new StringBuffer()
//                .append(" ON DUPLICATE KEY UPDATE ")
//                .append(FundRiskStats.Column.endDate.getEscapedColumnName() + "= :" + FundRiskStats.Column.endDate.getJavaProperty())
//                .append(FundRiskStats.Column.maxdrawdown1y.getEscapedColumnName() + "= :" + FundRiskStats.Column.maxdrawdown1y.getJavaProperty())
//                .append(FundRiskStats.Column.maxdrawdown2y.getEscapedColumnName() + "= :" + FundRiskStats.Column.maxdrawdown2y.getJavaProperty())
//                .append(FundRiskStats.Column.maxdrawdown3y.getEscapedColumnName() + "= :" + FundRiskStats.Column.maxdrawdown3y.getJavaProperty())
//                .append(FundRiskStats.Column.maxdrawdown4y.getEscapedColumnName() + "= :" + FundRiskStats.Column.maxdrawdown4y.getJavaProperty())
//                .append(FundRiskStats.Column.maxdrawdown5y.getEscapedColumnName() + "= :" + FundRiskStats.Column.maxdrawdown5y.getJavaProperty())
//                .append(FundRiskStats.Column.maxdrawdownIncep.getEscapedColumnName() + "= :" + FundRiskStats.Column.maxdrawdownIncep.getJavaProperty())
//                .append(FundRiskStats.Column.updateTime.getEscapedColumnName() + "= :" + FundRiskStats.Column.createTime.getJavaProperty());
//
//        String sql = insertSql + updateSql.toString();
//        SqlParameterSource sqlParameterSource = new BeanPropertySqlParameterSource(p);
//        namedParameterJdbcTemplate.update(sql, sqlParameterSource);
//    }
//
//    /**
//     * 计算年化波动率的起始日期
//     *
//     * @param proDisFre
//     * @param endDate
//     * @param timeType
//     * @return
//     */
//    private Date annualStartDate(int proDisFre, Date endDate, int timeType) {
//        Date befOrAfDay;
//        if (proDisFre == ProDisFreEnums.Day.getType() ||
//                proDisFre == ProDisFreEnums.Week.getType()) {
//            //披露频率为天 按周收益率求年化波动率
//            befOrAfDay = DateUtils.getBeginDayOfWeek(DateUtils.getBefOrAfDay(endDate, 51 * timeType * 7));
//
//        } else if (proDisFre == ProDisFreEnums.HalfMonth.getType()
//                || proDisFre == ProDisFreEnums.Month.getType()) {
//            //披露频率为半月或者月 按月收益率求年化波动率
//            befOrAfDay = DateUtils.getBeginDayOfMonth(DateUtils.getAfterMonths(endDate, -12 * timeType - 1));
//
//        } else {
//            //TODO 披露频率为季 按季收益率求年化波动率？
//            //                befOrAfDay = DateUtils.
//            befOrAfDay = null;
//        }
//        return befOrAfDay;
//    }
//
//    /**
//     * 获取当前基金历经了几年
//     *
//     * @param startDate 净值初次披露日期
//     * @param endDate   最近一次净值披露日期
//     * @return
//     */
//    private int sectionYears(Date startDate, Date endDate) {
//        int years = 0;
//        for (int i = 0; i < 5; i++) {
//            Date afterYear = DateUtils.getAfterYears(endDate, -i);
//            if (DateUtils.daysBetween(startDate, afterYear) > 0) {
//                years++;
//            } else {
//                break;
//            }
//        }
//        return years;
//    }
//
//}
